/*******************************************************************
 * Programm....: admindb.cc                                        *
 * Zweck.......: Auflisten,lschen und neuanlegen von Eintrgen in *
 *               einer Berkley-DB                                  *
 * Author......: Rudolf Weber Informatikberatung Ravensburg        *
 * Copyright 1998 nach GNU Copyleft                                *
 *******************************************************************/
#include<stdio.h>
#include<assert.h>
#include<errno.h>
#include"logmsg.h"
#include"usercachedb_db.h"
#include"usersparse.h"
#include"config.h"
Attrdict dict;
Usercachedb_db udb;
char *progname;
int debugflags=0;
char buffer[4048];

enum Command { bef_list=0,bef_del=1,bef_new=2 };

void usage()
{
  cerr << "Aufruf: " << progname << "<dbname> [del|new] <username>\n";
}

main(int argc,char **argv)
{
    char *username;
    Cacherecverw urv(buffer,4048);
    Command befehl=bef_list;
    int dbflags = UDB_READ;
    char **arg;
    progname=argv[0];

    logmsginit(LOGMSG_STDERR,progname,0,0);
    if(argc<3)
    {
      usage();
      exit(1);
    }
    
    
    arg=argv+2;
    if(strcmp("del",*arg)==0)
    {
      befehl=bef_del;
      dbflags = UDB_WRITE;
      arg++;
    }
    else if(strcmp("new",*arg)==0)
    {
      befehl=bef_new;
      dbflags = (UDB_CREATE|UDB_WRITE);
      arg++;
    }
    username=*arg;

    try
    {
      dict.init(RADDICT);
      udb.init(argv[1],dbflags);
    }
    catch(DbException &dbe)
    {
      logmsg(LOG_ERR,dbe.what());
      exit(1);
    }

    switch(befehl)
    {
    case bef_list:
      {
	try
	{
	  if(udb.lese(username,strlen(username),&urv)>=0)
	  {
	    urv.print(username,cout);
	  }
	  else
	  {
	    cout << "Nutzer " << username << " nicht gefunden ! \n";
	  }
	}
	catch(DbException &dbe)
	{
	  logmsg(LOG_ERR,dbe.what());
	}
      }
      break;
    case bef_del:
      {
	if(username==NULL) { usage(); exit(1); }
	try
	{
	  if(udb.loesche(username)>=0)
	  {
	    cerr << "Nutzer " << username << " wurde gelscht\n";
	  }
	  else
	  {
	    cerr << "Nutzer " << username << " nicht gefunden ! \n";
	  }
	}
	catch(DbException &dbe)
	{
	  logmsg(LOG_ERR,dbe.what());
	}
      }
      break;
    case bef_new:
      {
	Userprofscanner u(dict);
	char name[128];

	u.init(stdin);
	if(u.parseuserprofile(name,&urv)!=ENDE)
	{
	  try
	  {
	    urv.print(name,cerr);
	    udb.schreibe(name,&urv);
	  }
	  catch(DbException &dbe)
	  {
	    logmsg(LOG_ERR,dbe.what());
	  }
	}
      }
      break;
    default:
      cerr << "OOPS !!!!" << endl;
    }
    udb.close();
}


