/*******************************************************************
 * Programm: listusers.cc                                          *
 * Zweck...: Ausdrucken einer Usercachedb mit Berkley db           *
 * Author..: Rudolf Weber Informatik-Beratung Ravensburg           *
 * Copyright: 1997 GNU                                             *
 *******************************************************************/
#include<unistd.h>
#include<sys/time.h>
#include<iostream.h>
#include<stdlib.h>
#include<string.h>
#include"logmsg.h"
#include"usercachedb_db.h"
#include"config.h"
Attrdict dict;
Usercachedb_db udb;
char *progname;
int debugflags=0;
char buffer[4048];

main(int argc,char **argv)
{
    char *dbname;
    Cacherecverw urv(buffer,4048);
    int r=0;
    struct timeval jetzt;
    auth_attr *timeoutattr;
    gettimeofday(&jetzt,NULL);
    progname=argv[0];
    char **arg=argv+1;
 

    if(strcmp(*arg,"--reo")==0) { r=1; arg++; }
    if(*arg==NULL) 
    {
      cerr << "Aufruf: listusers <dbrel>\n";
      exit(1);
    }
    logmsginit(LOGMSG_STDERR,progname,0,0);
    dbname=*arg;
    
    dict.init(RADDICT);
    try
    {
      udb.init(dbname,0); // (r ? GDBM_WRITER : GDBM_READER));
    }
    catch(DbException &dbe)
    {
      logmsg(LOG_ERR,dbe.what());
      exit(1);
    }

    try
    {
      for(Usercachedbit_db it(udb,&urv);it()!=NULL;it.next())
      {
	const char *user = it();
	if(r)
	{
	  CRDienst *check=urv.findedienst(0);
	  if(check==NULL) // Paranoya
	  {
	    cerr << "Kein check-liste bei \n";
	    urv.print(user,cout);
	    continue;
	  }
	  timeoutattr = urv.finde(ASCEND_PW_EXPIRATION);
	  if(timeoutattr != NULL && (long)getintval(timeoutattr)<jetzt.tv_sec)
	  {
	    cout << "Eliminiere " << user << "\n";
	    udb.loesche(user);
	  }
	}
	else
	{
	  urv.print(user,cout);
	}
      }
      udb.close();
    }
    catch(DbException &dbe)
    {
      logmsg(LOG_ERR,dbe.what());
      exit(1);
    }
}

