/********************************************************************
 * Header....: usercachedb_db.h                                     *
 * Zweck.....: Deklariert Cache-Datenbank  (berkley-db)             *
 * Author....: Rudolf Weber informatikberatung Ravensburg           *
 * Copyright 1997 GNU_Copyleft                                      *
 ********************************************************************/
#ifndef USERCACHEDB_DB_H
#define USERCACHEDB_DB_H
#include<db_cxx.h>
#include"cache/usercachedb.h"


class Usercachedb_db : public Usercachedb
{
protected:
  static DbEnv dbenv;
  static DbEnv *dbenvp; // Kontrolle, ob schon gemacht
  static DbEnv *init_dbenv();
  
  Db *db;
  int isopen;
public:
  Usercachedb_db() { isopen=0; }
  int init(char *datname,int flags);
  int close();
  int schreibe(const char *name,Cacherecverw *urv);
  int loesche(const char *name);
  int lese(const char *name,int nlen,Cacherecverw *urv); 
  ~Usercachedb_db() { close(); }
  friend class Usercachedbit_db;
};

class Usercachedbit_db
{
  Dbc *iterator;
  char name[256];
  Dbt key;
  Dbt data;
  Cacherecverw *i_urv;
  int status;
public:
  Usercachedbit_db(Usercachedb_db &db,Cacherecverw *urv)
    {
      i_urv = urv;
      name[0]='\0';
      key.set_data(name);
      key.set_ulen(256);
      key.set_flags(DB_DBT_USERMEM);
      data.set_data(urv->data());
      data.set_ulen(urv->bufgross());
      data.set_flags(DB_DBT_USERMEM);
      db.db->cursor(0,&iterator);
      next();
    }
  const char *next()
    {
      status = iterator->get(&key,&data,DB_NEXT);
      if(status == 0)
      {
	name[key.get_size()]='\0'; 
      }
      else
	return (char *)NULL;
    }
  const char *operator()()
    {
      return (status == 0 ? name : (char *)NULL);
    }
  Cacherecverw *rec() { return (status==0 ? i_urv : (Cacherecverw *)NULL); }

  ~Usercachedbit_db()
    {
      iterator->close();
    }
}; 
#endif




