/*******************************************************************
 * Programm: listusers.cc                                          *
 * Zweck...: Ausdrucken einer Usercachedb                          *
 * Author..: Rudolf Weber Informatik-Beratung Ravensburg           *
 * Copyright: 1997 GNU                                             *
 *******************************************************************/
#include<unistd.h>
#include<sys/time.h>
#include<iostream.h>
#include<stdlib.h>
#include<string.h>
#include"usercachedb_gdbm.h"
#include"config.h"
Attrdict dict;
Usercachedb_gdbm udb;
char *progname;
int debugflags=0;


main(int argc,char **argv)
{
    char *dbname;
    Cacherecverw urv;
    int r=0;
    struct timeval jetzt;
    auth_attr *timeoutattr;
    gettimeofday(&jetzt,NULL);
    progname=argv[0];
    char **arg=argv+1;
 
    if(strcmp(*arg,"--reo")==0) { r=1; arg++; }
    if(*arg==NULL) 
    {
      cerr << "Aufruf: listusers <gdbmuserhashtablefile>\n";
      exit(1);
    }
    dbname=*arg;
    
    dict.init(RADDICT);
    udb.init(dbname,( r ? UDB_WRITE : UDB_READ));
    
    for(Usercachedbit_gdbm it(udb);it()!=NULL;it.next())
    {
       char *user = it();
       udb.lese(user,strlen(user),&urv);
       if(r)
       {
	 CRDienst *check=urv.findedienst(0);
	 if(check==NULL) // Paranoya
	 {
	   cerr << "Kein check-liste bei \n";
	   urv.print(user,cout);
	   continue;
	 }
	 timeoutattr = urv.finde(ASCEND_PW_EXPIRATION);
	 if(timeoutattr != NULL && (long)getintval(timeoutattr)<jetzt.tv_sec)
	 {
	   cout << "Eliminiere " << user << "\n";
	   udb.loesche(user);
	 }
       }
       else
       {
	 urv.print(user,cout);
       }
    }
    if(r)
    {
      cerr << "\n Reorganisiere Radiusdb " << endl;
      udb.reorganize();
    }
}

