/*********************************************************************
 * Modul...: usercachedb.cc                                          *
 * Zweck...: Implementiert Usercachedatenhaltung mit gdbm            *
 *********************************************************************/
#include<iostream.h>
#include<stdlib.h>
#include<assert.h>
#include"usercachedb_gdbm.h"

static void fatalfunc(char *errmsg)
{
  cerr << "gdbmerror: " << errmsg << endl;
  exit(1);
}

int Usercachedb_gdbm::schreibe(const char *name,Cacherecverw *urv)
{
   datum schl;
   datum nutz;

   schl.dptr = name;
   schl.dsize = strlen(name);
   
   nutz.dptr = (char *)(urv->data());
   nutz.dsize = urv->totallen();
   gdbm_store(fp,schl,nutz,GDBM_REPLACE);
}

int Usercachedb_gdbm::init(char *datei,int flags)
{
   int db_flags=0;
   assert(!((flags&UDB_WRITE)==0 && (flags&UDB_CREATE)==UDB_CREATE));
   if((flags&UDB_WRITE)==0) db_flags=GDBM_READER;
   if((flags&UDB_CREATE)==UDB_CREATE) db_flags|=GDBM_WRCREAT;
  
   strcpy(dateiname,datei);
   fp=gdbm_open(dateiname,0,db_flags,0600,fatalfunc);
   if(fp==NULL)
   {
       cerr << gdbm_strerror(gdbm_errno);  
       exit(1);
   }
   key.dptr = NULL;
   satz.dptr = NULL;
   
}

int Usercachedb_gdbm::lese(const char *name,int nlen,Cacherecverw *urv)
{
    if(satz.dptr != NULL) { free(satz.dptr); satz.dptr=NULL;}
    key.dptr = name;
    key.dsize = nlen;
    satz = gdbm_fetch(fp,key);
    if(satz.dptr == NULL) return -1;
    urv->setbuffer(satz.dptr,satz.dsize);
    return 0;
}

int Usercachedb_gdbm::loesche(const char *name)
{
    key.dptr = name;
    key.dsize = strlen(name);
    return gdbm_delete(fp,key);
}

#ifdef USERQUERY
#include"config.h"
Attrdict dict;
Usercachedb_gdbm udb;
char *progname;
int debugflags=0;

main(int argc,char **argv)
{
    char name[256];
    Cacherecverw urv;
  
    if(argc<2)
    {
      cerr << "Aufruf: userquery <gdbmdatei>\n";
      exit(1);
    }
    progname=argv[0];
    dict.init(RADDICT);
    udb.init(argv[1],UDB_READ);

    cout << "Username ?";
    cin >> name;
    while(!cin.eof())
    {
	
	if(udb.lese(name,strlen(name),&urv)>=0)
	{
	    urv.print(name,cout);
	}
	else
	{
	    cout << "Nutzer " << name << " nicht gefunden ! \n";
	}
	cout << "Username ?";
	cin >> name;
    }
}
#endif












