/********************************************************************
 * Header....: usercachedb_gdbm.h                                   *
 * Zweck.....: Deklariert Cache-Datenbank (gdbm)                    *
 * Author....: Rudolf Weber informatikberatung Ravensburg           *
 * Copyright 1997 GNU_Copyleft                                      *
 ********************************************************************/
#ifndef USERCACHEDB_GDBM_H
#define USERCACHEDB_GDBM_H
#include<gdbm.h>
#include<usercachedb.h>


class Usercachedb_gdbm: public Usercachedb
{
private:
  char dateiname[80];
  datum key;
  datum satz;
  GDBM_FILE fp;
public:
  int init(char *datname,int flags); // flags siehe gdbm
  int schreibe(const char *name,Cacherecverw *urv);
  int loesche(const char *name);
  int lese(const char *name,int nlen,Cacherecverw *urv);
  close() { gdbm_close(fp);}
  int reorganize() { return gdbm_reorganize(fp); }

  friend class Usercachedbit_gdbm;
}; 

class Usercachedbit_gdbm
{
  Usercachedb_gdbm *udb;
  datum key;
  char *oldptr;
  char puffer[256];
public:
  Usercachedbit_gdbm(Usercachedb_gdbm& db)
  {
    udb = &db;
    key = gdbm_firstkey(udb->fp);
    if(key.dptr!=NULL)
    {
      memcpy(puffer,key.dptr,key.dsize);
    }
    else
    {
      key.dsize=0;
    }
    puffer[key.dsize]='\0';
  }
  const char *next() 
  {
    oldptr = key.dptr;
    key = gdbm_nextkey(udb->fp,key);
    if(key.dptr!=NULL)
    {
      memcpy(puffer,key.dptr,key.dsize);
    }
    else
    {
      key.dsize=0;
    }
    puffer[key.dsize]='\0';
    free(oldptr);
    return (key.dptr != NULL ? puffer : (char *)0);
  }                   
  const char *operator()() { return (key.dptr != NULL ? puffer : (char *)0); }
};

#endif
