
#include<assert.h>
#include"usercache.h"

void Cacherecverw::setbuffer(char *buffer,int len)
{
  ur = (Cacherecord *)buffer;
  buflen=len;
}

void Cacherecverw::setbuffer(Cacherecord *c)
{
  ur = c;
  buflen=totallen();
}

int Cacherecverw::totallen()
{
  CRDienst *akt;
  int ret = sizeof(u_int32_t)+ur->ng*sizeof(CRDienst);

  for(akt=ersterdienst();akt!=NULL;akt=weitererdienst())
  {
    ret+=akt->lang;
  }
  return ret;
}

//----- Iteratoren --------
//   Dienstiterator
CRDienst *Cacherecverw::ersterdienst() 
{
  if(ur->ng>0)
  {
    aktdnr=1;
    return (aktd= &(ur->data));
  }
  else
  {
    return (CRDienst *)0;
  }
}

CRDienst *Cacherecverw::weitererdienst()
{
  if(aktdnr<ur->ng)
  {
    aktd=(CRDienst *)((u_char *)ur+aktd->offset+aktd->lang);
    aktdnr++;
    return aktd;
  }
  else
  {
    return (CRDienst *)0;
  }
}

CRDienst *Cacherecverw::findedienst(UINT4 dn)
{
  CRDienst *ret = ersterdienst();
  while(ret!= NULL && ret->dienst != dn) ret=weitererdienst();
  first(ret); // Fr Attribut-Finde
  return ret;
}


/*------ Attributiterator --------------------*/
auth_attr *Cacherecverw::first(CRDienst *d) 
{
  if(d==NULL) return (auth_attr *)NULL;
  aktd=d;
  ptr = (u_char *)ur+aktd->offset;
  eptr = ptr+aktd->lang;
  return (aktd->lang > 0) ? (auth_attr *)ptr : (auth_attr *)NULL;
}

auth_attr *Cacherecverw::next()
{
  if(ptr < eptr)
  {
    ptr += (int)(((auth_attr *)ptr)->len);
  }  
  return (ptr < eptr ? (auth_attr *)ptr : (auth_attr *)NULL);
}

auth_attr *Cacherecverw::finde(u_char attribut)
{
  assert(aktd!=NULL && eptr==(u_char *)erstes(aktd)+aktd->lang 
    && (u_char *)erstes(aktd) <= ptr && ptr <= eptr );

  if(ptr >= eptr) ptr=(u_char *)erstes(aktd);
  u_char *anf = ptr;
  int i=0;
  if(aktd->lang == 0) return NULL;
  
  //Zyklisches durchsuchen aller Attribute
  while(((auth_attr *)ptr)->id != attribut && (ptr!=anf || i==0))
  {
    ptr += ((auth_attr *)ptr)->len;
    if(ptr >= eptr) ptr=(u_char *)erstes(aktd);
    i++;
  }
  return (((auth_attr *)ptr)->id == attribut ? (auth_attr *)ptr : (auth_attr *)NULL);
}

/*------------ Aufbauiteratoren --------------------------*/
void Cacherecverw::neuerdienst(UINT4 dn)
{
  
  // Positionre auf den Letzten Dienst
  for(CRDienst *akt=ersterdienst();akt!=NULL;akt=weitererdienst());
  ur->ng++;

  aktd = ( ur->ng > 1 ? (CRDienst *)ende(aktd) : aktd = &(ur->data));
  // verbessern: Platz im Puffer 

  aktd->dienst=dn;
  aktd->czeit=0;
  ptr=eptr=(u_char *)aktd+sizeof(CRDienst);
  aktd->offset = eptr - (u_char *)ur;
  aktd->lang=0;
}

void Cacherecverw::dienstcachetime(time_t t)
{
  assert(aktd!=NULL);
  aktd->czeit=t;
}

int Cacherecverw::add(Attreintrag *attr,char *value)
{
  assert(aktd!=NULL && eptr == ende(aktd));
  int ret;
  auth_attr *merk = (auth_attr *)eptr;
  if((ret = addattrtolist(eptr,attr,value))>0)
  {
    aktd->lang+=merk->len;
  }
  return ret;
}

int Cacherecverw::add(u_char attribut,char *value,int len)
{
  int ret;
  
  auth_attr *merk = (auth_attr *)eptr;
  if((ret = addattributtolist(eptr,attribut,value,len))>0)
  {
    aktd->lang+=merk->len;
  }
  return ret;  
}

int Cacherecverw::add(u_char attribut,UINT4 w)
{
  UINT4 v = htonl(w);
  return add(attribut,(char *)&v,sizeof(UINT4));
}

int Cacherecverw::add(auth_attr *a)
{
  assert(aktd!=NULL && eptr == ende(aktd));
  if(a ==NULL) return 0; // arbeitet mit finde gut zusammen !
  memcpy(eptr,(char *)a,a->len);
  eptr += a->len;
  aktd->lang += a->len;
  return 0;
}

int Cacherecverw::addm(auth_attr *ma,int len)
{
  assert(aktd!=NULL && eptr == ende(aktd));
  if(aktd ==NULL) return 0; // arbeitet mit finde gut zusammen !
  memcpy(eptr,(char *)ma,len);
  aktd->lang += len;
  eptr+=len;
  return 0;
}

/*--------------- Ausgabe ---------------------*/
extern Attrdict dict;
void Cacherecverw::print(ostream &ostr)
{
  Attreintrag *service = dict[PW_USER_SERVICE_TYPE];
  Attreintrag *proto   = dict[PW_FRAMED_PROTOCOL];
  CRDienst *ad;int dnr=0;
  auth_attr *akt;
  UINT4 h;
  for(ad=ersterdienst();ad!=NULL;ad=weitererdienst())
  {
    dnr++;
    if(ad->dienst == 0) continue; // Checkliste ueberlesen
    h = htonl(hauptdienst(ad->dienst));
    cout << "  Service(";
    service->print(ostr,(u_char *)&h,4,0);
    if((h=dienstattr(ad->dienst))!=0)
    {
      h=htonl(h);
      cout << ',';
      proto->print(ostr,(u_char *)&h,4,0);
    }
    cout <<")";
    cout <<"\n   {\n";

    akt=first(ad);
    if(akt != NULL)
    {
      for(;akt!=NULL;akt=next())
      {
	ostr << "   \t";
	akt->print(ostr);
	ostr << '\n';
      }
    }
    cout <<"   }";

    cout << (dnr < ur->ng ? ',' : '\n') << endl;
  }
}

void Cacherecverw::print(const char *username,ostream &ostr)
{
  int c=0;

  CRDienst *check = findedienst(0);
  ostr << username << " ";
  for(auth_attr *akt = first(check);akt != NULL;akt=next())
  {
    if(c) ostr << ',';
    akt->print(ostr);
    c++;
  }
  ostr << endl;
  print(ostr);
}

/* -------- Ntzliche Routinen --------------*/
void Cacherecverw::copydienst(CRDienst *fdienst,Cacherecverw *cr2)
{
  neuerdienst(fdienst->dienst);
  dienstcachetime(fdienst->czeit);
  memcpy(eptr,(char *)(cr2->erstes(fdienst)),fdienst->lang);
  aktd->lang=fdienst->lang;
}

void Cacherecverw::copyreplace(u_char attribut,char *wert,int len,UINT4 d,Cacherecverw *cr2)
{
  int ers=0;
  CRDienst *fdienst = cr2->findedienst(d);
  if(fdienst==NULL) return;
  neuerdienst(d);
  for(auth_attr *akt = cr2->first(fdienst);akt!=NULL;akt=cr2->next())
  {
    if(akt->id == attribut)
    {
      add(attribut,wert,len);
      ers=1;
    }
    else
    {
      add(akt);
    }
  }
  if(!ers)
  {
    add(attribut,wert,len);
  }
}


void Cacherecverw::mcopyreplace(auth_attr *a,int len,UINT4 d,Cacherecverw *cr2)
{
  CRDienst *fdienst = cr2->findedienst(d);

  neuerdienst(d);
  addm(a,len);
  
  if(fdienst==NULL) return;
  for(auth_attr *altakt=cr2->erstes(fdienst);altakt!=NULL;altakt=cr2->next())
  {
    if(!finde(altakt->id))
    {
      add(altakt);
    }
  }
}


