/***************************************************************
 * Headerfile....: userparse.h                                 *
 * Klasse Userscanner
 * Klasse Userprofscanner  liest ein Userprofile               *
 ***************************************************************/
#ifndef USERSPARSE_H
#define USERSPARSE_H
#include"cache/raarscanner.h"
#include"cache/usercache.h"

const int ENDE=-1;          //-1 : EOF
const int KOMMZEILE=0;     // 0 : Komentarzeile
const int EINRUCKZEILE = 1;// 1 : eingerckt
const int BEGINNZEILE  = 2;// 2 : sofort beginnend
const int LEERZEILE    = 3; // 3 : Leerzeile
const int SERVICEZEILE = 4; // Service(
const int BLOCKBEGIN   = 5;
const int BLOCKENDE    = 6;

const int OK=0;
const int ERROR=1;

class Userservicescanner : public RaarScanner
{
private:
    Attreintrag *service;
    Attreintrag *proto;
protected:
    // Allgemeine Routinen
    int nextline();
    int zustand;
public:
    Userservicescanner(Attrdict &dict);
       
    int getpaar(Cacherecverw *urv);
    UINT4 getdienst();
    int readreplylist(Cacherecverw *urv);
    int parsedienste(Cacherecverw *urv);
};

class Userprofscanner : public Userservicescanner
{
protected:
    int nextprofile()
    {
	int ret;
	while((ret = nextline()) != ENDE && ret != BEGINNZEILE);
	return ret;
    }
public:
    Userprofscanner(Attrdict &dict):Userservicescanner(dict) {}
    int parseuserprofile(char *name,Cacherecverw *urv);
};

class Usertemplate : public Userservicescanner
{
public:
  Usertemplate(Attrdict &dict):Userservicescanner(dict) {}
  int genprofile(char *pass,char *outdate,Cacherecverw *urv);
};

#endif

