/*
 * $Id: local.c,v 1.2 1996/09/15 11:36:36 lf Exp $
 *
 * Copyright(C) 1996 Lars Fenneberg
 *
 * See the file COPYRIGHT for the respective terms and conditions. 
 * If the file is missing contact me at lf@elemental.net 
 * and I'll send you a copy.
 * Zweck...: Behandlung des lokalen logins 
 */

#include<iostream.h>
#include<unistd.h>
#include<pwd.h>
#include<errno.h>
#include<sys/types.h>
#include"logmsg.h"
#include"radius.h"
#include"config.h"
#include"radiusclient.h"
#include"clientmessages.h"
#include"radlogin.h"

#ifdef SHADOW_PASSWORD
#include<shadow.h>
#endif

extern Clientconf clientcf;

LFUNC auth_local(char *username, char *passwd,Env& environ)
{
  struct passwd *pw;
  char *xpasswd;
#ifdef SHADOW_PASSWORD
  struct spwd *spw;
#endif

  if((pw = getpwnam(username)) == NULL)
  {
    endpwent();
    logmsg(LOG_NOTICE, "authentication FAILED, type local, username %s", username);
    printf(SC_LOCAL_FAILED);
    return NULL;
  }
  endpwent();

#ifdef SHADOW_PASSWORD
  if((spw = getspnam(pw->pw_name)) == NULL)
  {
    endspent();
    logmsg(LOG_NOTICE, "authentication FAILED, type local, username %s", username);
    printf(SC_LOCAL_FAILED);
    return NULL;
  }
  else
  {
    pw->pw_passwd = spw->sp_pwdp;
  }
  endspent();
#endif /* SHADOW_PASSWORD */

  xpasswd = crypt(passwd, pw->pw_passwd);

  if(*pw->pw_passwd == '\0' || strcmp(xpasswd, pw->pw_passwd))
  {
    logmsg(LOG_NOTICE, "authentication FAILED, type local, username %s", username);
    printf(SC_LOCAL_FAILED);
    return NULL;
  }

  logmsg(LOG_NOTICE, "authentication OK, type local, username %s", username);
  printf(SC_LOCAL_OK);

  return local_login;
}

void local_login(char *username,Env& environ)
{
  char *login_local = clientcf.login_local;

  /* login should spot this... but who knows what old /bin/logins
   * may be still around
   */
  if(*username == '-')
  {
    logmsg(LOG_WARNING, "username can't start with a dash");
    exit(-1);
  }
  /* the new shadow login seems to require either a -r or a -h
   * flag for -f to work(so source code, lmain.c) so we supply
   * it here. shouldn't hurt on other systems,    -lf, 03/13/96
   */
  execle(login_local, login_local, "-h", "localhost", "-f", username, NULL, environ.export());
  logmsg(LOG_ERR, "couldn't execute %s: %s", login_local, strerror(errno));
  sleep(1);			/* give the user time to read */
  exit(-1);
}



