/**********************************************************
 * Programm...: radadmin                                  *
 * Zweck......: User hinzufgen, lschen und Modifizieren *
 *              ber den Radiusd                          *
 **********************************************************/
#include<iostream.h>
#include<stdio.h>
#include"zeit.h"
#include"radius.h"
#include"radiusclient.h"
#include"config.h"
#include"usersparse.h"

int leseattrparam(Userrecverw *urv,char **&arg);
int listusers(int usock,struct sockaddr_in& saremote,const u_char *secret,char *realm);

Attrdict dict;
Clients clients;
int debugflags=0;
char *progname;
char buffer[4096];
char updbuffer[1024];
const int RCVBUF_SIZE=4096;
const int SNDBUF_SIZE=4096;
char recvbuffer[RCVBUF_SIZE];
char sendbuffer[SNDBUF_SIZE];
Zusenden ar(sendbuffer,SNDBUF_SIZE);
Empfangen antwort(recvbuffer,RCVBUF_SIZE);

main(int argc,char **argv)
{
  Clientconf clientcf;
  char *dictdir = clientcf.dictpath;
  char *clientspath = clientcf.clientpath;
  char *profiletempl = clientcf.tmpl;
  char **arg=argv+1; // Parameteriterator
  char *username;
  char *realm=clientcf.default_realm;
  char *urealm;
  char username_realm[256];
  u_char anforderung=PW_RW_USERQUERY_REQUEST;
  Userrecverw upd(updbuffer);
  Userrecverw templ(buffer); 
  Userrecverw satz(buffer+2048);
  Userrecverw *ergsatz=NULL;
  auth_attr *akt;
  int sockfd;
  struct sockaddr_in salocal;
  progname=argv[0];
 
  // Optionen und Befehle
  while(*arg != NULL && (**arg == '-'))
  {
    if(strcmp("--dict",*arg)==0) dictdir = *(++arg);
    else if(strcmp("--clients",*arg)==0) clientspath = *(++arg);
    else if(strcmp("-H",*arg)==0)
    {
      Server *sv = new Server(*(++arg));
      sv->nxt = clientcf.radhosts;
      clientcf.radhosts=sv;
    }
    else if(strcmp("-R",*arg)==0) realm = *(++arg);
    else if(strcmp("--list",*arg)==0) anforderung=PW_RW_LISTUSER_REQUEST;
    else if(strcmp("--upd",*arg)==0) anforderung=PW_RW_USERUPD_REQUEST;
    else if(strcmp("--new",*arg)==0) anforderung=PW_RW_NEWUSER_REQUEST;
    else if(strcmp("--del",*arg)==0) anforderung=PW_RW_NEWUSER_REJECT;
    else if(strcmp("--templ",*arg)==0) profiletempl = *(++arg);
    else if(sscanf(*arg,"-d%d",&debugflags)==1) ; 
    arg++;
  }
  if(debugflags) cout << "Debuglevel " << debugflags << endl;
  dict.init(dictdir);
  clients.init(clientspath);
  u_char nullvector[AUTH_VECTOR_LEN];
  memset((char *)nullvector,'\0',AUTH_VECTOR_LEN);

  sockfd = opensocket(salocal);
  salocal.sin_addr = myaddr();
   
  const Clientinfo * clinfo = clients.finde(salocal.sin_addr,realm);
  if(clinfo == NULL)
  {
    cerr << "Von Rechner " << salocal << " sind Aktionen nicht erlaubt!\n";
    exit(1);
  }
  cerr <<  "Absender " << salocal
#ifdef DEBUG
       <<  " Secret: " << clinfo->secret
#endif
       <<  " Radiusserver " << clientcf.radhosts->name()
       << endl;
  if(anforderung == PW_RW_LISTUSER_REQUEST)
  {
    listusers(sockfd,clientcf.radhosts->addr(),clinfo->secret,realm); exit(0);
  }
  if(*arg == NULL) { cerr << "Kein Username angegeben !" << endl;exit(1);}
  if(index(*arg,'=')!=NULL) { cerr << "Username mit '=' ??? " << endl;exit(1);}
  username = *(arg++);

  strncpy(username_realm, username, sizeof(username_realm));
   
  /* Append default realm */
  urealm = strchr(username_realm, '@');
  if (urealm == NULL)
  {
    if(realm && *realm != '\0')
    {
      strncat(username_realm, "@", sizeof(username_realm));
      strncat(username_realm, realm, sizeof(username_realm));
    }
    else realm = "";
  } 
  else
  { 
    urealm++;
    if(strcmp(urealm,realm)!=0)
    {
      // Nun so was, brauche neues clientsecurityinfo
      clinfo = clients.finde(salocal.sin_addr,urealm);
      if(clinfo == NULL)
      {
	cerr << "Von Rechner " << salocal << " und mit Realm " 
	     << urealm << " sind Aktionen nicht erlaubt!\n";
	exit(1);
      }
    }
  }
  cout << "User " << username_realm << "\n";

  ar.initsend(anforderung,(u_char)seqnr(clientcf.seqfile),nullvector);
  ar.addattr(PW_USER_NAME,username_realm,strlen(username_realm));
  if(anforderung == PW_RW_NEWUSER_REQUEST)
  {
    Userprofscanner u(dict);
    char name[256];
    u.init(profiletempl);
    u.parseuserprofile(name,&templ);
    if(debugflags & 4)
    {
      cout << "Das User-Template:\n";templ.print(cout);cout << endl;
    }
  }

  if(anforderung == PW_RW_USERUPD_REQUEST || anforderung == PW_RW_NEWUSER_REQUEST)
  {
    int totallen;
    leseattrparam(&upd,arg);
    ergsatz = &upd;
    
    if(anforderung == PW_RW_NEWUSER_REQUEST)
    {
      cout << "Update-Satz:\n";
      upd.print(cout);
      satz.update(upd,templ);
      ergsatz=&satz;
    }
    cout << "Satz : " << endl;
    ergsatz->print(cout);
    
    totallen = ergsatz->totallen();
    ergsatz->hton(); // ergsatz->totallen() ist nun nimmer zu gebrauchen !
    ar.addattr(PW_RW_USER_RECORD,(char *)(ergsatz->data()),totallen);
  }
  ar.calc_responsedigest(clinfo->secret);
    
  ar.send(sockfd,clientcf.radhosts->addr());
  antwort.recv(sockfd);
  cout << "Erhaltene Rckmeldung:\n";
  if(antwort.check_reply(ar.getvector(),(u_char *)(clinfo->secret))<0)
  {
    cout << "Reply-Digest stimmt aber nicht !\n";
  }
  else
  {
    cout << "Reply-Digest stimmt sogar ! \n";
  }
  antwort.print(cout);
  cout << "\n";
  // Lese Record aus nachricht
  if((akt=antwort.finde(PW_RW_USER_RECORD))!=NULL)
  {
    satz.setbuffer((char *)(akt->data));
    satz.ntoh();
    satz.print(cout);
  }
}

int leseattrparam(Userrecverw *urv,char **&arg)
{
  char puffer[256];
  int pool;
  int tag,monat,jahr;

  while(*arg != NULL)
  {
    if(sscanf(*arg,"pw=%s",puffer)==1)
    {
      if(debugflags &4)  cout << "Passwort=" << puffer << endl;
      urv->add(PW_PASSWORD,puffer,strlen(puffer),ATTR_CHECK);
    }
    else if(sscanf(*arg,"to=%d.%d.%d",&tag,&monat,&jahr)==3)
    {
      Datum dat(tag,monat,jahr);
      if(debugflags&4){cout << "Timeout-Datum ";dat.print(cout);cout<<endl;}
      UINT4 exps = (UINT4)sekzeit696(dat);
      urv->add(ASCEND_PW_EXPIRATION,exps,ATTR_CHECK);
    }
    else if(sscanf(*arg,"pool=%d",&pool)==1)
    {
      cout << "Ipadresspool ="<<pool<<'\n';
      urv->add(ASCEND_PW_ASSIGN_IP_POOL,(UINT4)pool,ATTR_REPLY);
    }
    else
    {
      cerr << "Parameter " << *arg << " nicht erkannt " << endl;
      return -1;
    }
    arg++;
  }
  return 1;
}

int listusers(int usock,struct sockaddr_in& saremote,const u_char *secret,char *realm)
{
  struct sockaddr_in meineadr;
  struct sockaddr_in kundeadr;
  int meineadrlen = sizeof(struct sockaddr_in);
  int kundeadrlen = sizeof(kundeadr);
  char errmsg[512];
  const int PUFLEN=1025;
  char puffer[PUFLEN+1];
  int gel;
  int tsock,ttsock;
  short port=0;
  u_char nullvector[AUTH_VECTOR_LEN];
  fd_set listenfds;
  struct timeval sto; /*Sockettimeout*/
  int ret;
  memset((char *)nullvector,'\0',AUTH_VECTOR_LEN);

  /* ffne TCP-Socket */
  if((tsock=socket(AF_INET,SOCK_STREAM,IPPROTO_TCP)) < 0)
  {
    sprintf(errmsg,"socket (%s:%d):",__FILE__,__LINE__);
    perror(errmsg);
    exit(1);
  }
  /* Binde an Adresse und waehle Portnr. frei falls port == 0; */
  bzero((char *)&meineadr,sizeof(meineadr));
  meineadr.sin_family = AF_INET;
  meineadr.sin_addr.s_addr = INADDR_ANY;
  meineadr.sin_port = 0;
  if((bind(tsock,(struct sockaddr *)&meineadr,sizeof(meineadr))) < 0)
  {
    sprintf(errmsg,"bind (%s:%d):",__FILE__,__LINE__);
    perror(errmsg);
    exit(1);
  }
  if(getsockname(tsock,(struct sockaddr *)&meineadr,&meineadrlen)<0)
  {   
    sprintf(errmsg,"getsockname (%s:%d):",__FILE__,__LINE__);
    perror(errmsg);
    exit(1);
  }
  if(debugflags)
  {
    cerr << "TCP-Port " << ntohs(meineadr.sin_port) << "\n";
  }

  listen(tsock,1);
  /* Sende Anforderungspaket */
  ar.initsend(PW_RW_LISTUSER_REQUEST,1,nullvector);
  if(realm != NULL || realm[0]!='\0')
  {
    puffer[0]='@';
    strncat(puffer,realm,sizeof(puffer));
    ar.addattr(PW_USER_NAME,puffer,strlen(puffer));
  }
  ar.addattr(PW_LOGIN_TCP_PORT,(UINT4)ntohs(meineadr.sin_port));
  ar.calc_responsedigest(secret);
  ar.send(usock,saremote);

  FD_ZERO(&listenfds);
  FD_SET(usock,&listenfds);
  FD_SET(tsock,&listenfds);
  sto.tv_sec = 20;
  ret = select((tsock>usock ? tsock+1 : usock+1),&listenfds,NULL,NULL,&sto);
  if(ret > 0)
  {
    if(FD_ISSET(tsock,&listenfds))
    {
      if((ttsock = accept(tsock,(struct sockaddr *)&kundeadr,&kundeadrlen))<0)
      {
	sprintf(errmsg,"accept (%s:%d):",__FILE__,__LINE__);
	perror(errmsg);
	exit(1); 
      }
      cout.flush();
      while((gel = read(ttsock,puffer,PUFLEN-1))>0)
      {
	int r;
	int rest = gel;
	char *ptr = puffer;
	while((r=write(1,ptr,rest))>0 && rest > 0)
	{
	  ptr += r;
	  rest -= r;
	}
      }
      close(ttsock);
    }
    else if(FD_ISSET(usock,&listenfds))
    {
      antwort.recv(usock);
      cout << "Erhaltene Rckmeldung:\n";
      if(antwort.check_reply(ar.getvector(),(u_char *)secret)<0)
      {
	cout << "Reply-Digest stimmt aber nicht !\n";
      }
      else
      {
	cout << "Reply-Digest stimmt sogar ! \n";
      }
      antwort.print(cout);
    }
  }
  else if(ret == 0)
  {
    cerr << "Warte vergeblich auf die Verbindung ..." << endl;
  }
  else
  {
     sprintf(errmsg,"select (%s:%d):",__FILE__,__LINE__);
     perror(errmsg);
     exit(1);
  }
  close(ttsock);
  close(tsock);
}














