/**************************************************************************
 * Programm...: radpass.cc                                                *
 * Zweck......: ndern des Radiuspassworts fr normale Benutzer           *
 *------------------------------------------------------------------------*
 * Rudolfs billiger Radius Daemon                                          *
 * Nun schlu mit der Bettnsserei - ich baue meinen eigenen Demon        *
 *                                                                        *
 * copyright: 1996 Rudolf Weber W-4 Nonnenbroich und Weber Gbr            *
 *                 Ravensburg,Germany                                     *
 * email: rw@w-4.de                                                       *
 * Rights: see GNU-Copyleft (Distribution only with Source-Code)          *
 * Comericial Users are ask to send money                                 *
 **************************************************************************/
#include<unistd.h>
#include<iostream.h>
#include<pwd.h>
#include<string.h>
#include<getopt.h>
#include"etext.h"
#include"nachricht.h"
#include"pwchecks.h"
#include"radiusclient.h"
#include"config.h"

const int RCVBUF_SIZE=8192;
const int SNDBUF_SIZE=4096;
char recvbuffer[RCVBUF_SIZE];
char sendbuffer[SNDBUF_SIZE];
Attrdict dict;
int debugflags=0;
char *progname;

main(int argc,char **argv)
{
  int debugflags=0;
  char eingabepuffer[256];
  char *username;
  char username_realm[256];
  char passalt[AUTH_PASS_LEN];
  char passneu1[AUTH_PASS_LEN];
  char passneu2[AUTH_PASS_LEN];
  const char *ret;
  int l;
  int oi=0;
  int c;
  struct option long_options[] =
  {   {"dict",1,0,1 },
      {"clients",1,0,'c'},
      {0,0,0,0}
  };
  struct sockaddr_in absenderadr;
  Zusenden ar(sendbuffer,SNDBUF_SIZE);
  Empfangen antwort(absenderadr,recvbuffer,RCVBUF_SIZE);
  u_char vector[AUTH_VECTOR_LEN];
  struct sockaddr_in salocal;
  int sockfd;
  Clientconf clientcf(defaultclientconfigfile());
  char *dictdir = clientcf.dictpath;
  char *clientspath = clientcf.clientpath;
  progname = argv[0];

  while((c=getopt_long(argc,argv,"dH:c:",long_options,&oi))!=-1)
  {
    switch(c)
    {
    case 1:
      dictdir = optarg;
      cout << "Dict: " << dictdir << endl;
      break;
    case 'c':
      clientspath = optarg;
      break;
    case 'd': debugflags=1;
      break;
    case 'H':
        {
	  Server *sv = new Server(optarg);
	  sv->nxt = clientcf.radhosts;
	  clientcf.radhosts=sv;
	}
      break;
    default:
      cerr << "Unbekannte Option " << (char)c << endl;
    }
  }
  if(argc-optind >= 1)
  {
    username=argv[optind];
  }
  else
  {
    eingabepuffer[0]='\0';
    cerr << "Loginname ?";
    cin >> eingabepuffer;
    username = trim(eingabepuffer);
  }
  if(username[0]=='\0')
  {
    cerr << "radpass: Leerer Loginname ist nicht sinnvoll !" << endl;
    exit(1);
  }
  /* 
   * for RADIUS we login in as username@realm eventualy so
   * here we add an @realm part of username if not already
   * specified.
   */
  
  strncpy(username_realm, username, sizeof(username_realm));
  
  /* Append default realm */
  if ((strchr(username_realm, '@') == NULL) && clientcf.default_realm &&
      ((*(clientcf.default_realm)) != '\0'))
  {
    strncat(username_realm, "@", sizeof(username_realm));
    strncat(username_realm, clientcf.default_realm, sizeof(username_realm));
  }
  
  cout << "Pawort ndern fr " << username << ':' << endl;
  strcpy(passalt,getpass("Altes Pawort ?"));
  strcpy(passneu1,getpass("Neues Pawort ?"));
  strcpy(passneu2,getpass("Neues Pawort wiederholen?"));
  if(passalt[0]=='\0' || passneu1[0] == '\0' || passneu2[0] =='\0')
  {
    cerr << "radpass: Keine Eingabe bei mindestens einem der Passwrter\n"; 
    exit(1);
  }
  if(strcmp(passneu1,passneu2)!=0)
  {
    cerr << "Pawort falsch wiederholt (" << passneu1 << " != " << passneu2
         << ")\n";
    exit(1);
  }
  if((ret=checkpasswd(passneu1))!=NULL)
  {
    cerr << "radpass:Die gefrchtete Passwortcheckroutine empfindet das "
         << "Pawort \"" << passneu1 << "\" zu einfach: " << ret 
         << "\n-> nderung abgelehnt \n";
    exit(1);
  }

  dict.init(dictdir);

  sockfd = opensocket(salocal);
  cout << "Radiusserver " << clientcf.radhosts->name() << endl;
  random_vector(vector);
  ar.initsend(PW_PASSWORD_REQUEST,(u_char)seqnr(clientcf.seqfile),vector);
  ar.addattr(PW_USER_NAME,username_realm,strlen(username_realm));
  ar.calc_digest((const u_char *)passalt);
  
  l = strlen(passneu1);
  ciffrepassword((u_char *)passneu2,(u_char *)passneu1,l,ar.getdigest());
  ar.addattr(PW_PASSWORD,passneu2,l);
  
  l = strlen(passalt);
  ciffrepassword((u_char *)passneu2,(u_char *)passalt,l,ar.getdigest());
  ar.addattr(PW_OLD_PASSWORD,passneu2,l);

  if(debugflags)
  {
    cout << "zu sendende Anforderung:\n";
    ar.print(cout);  
  }
  ar.send(sockfd,clientcf.radhosts->addr()); 
  
  antwort.recv(sockfd);
  
  if(antwort.check_reply(vector,(u_char *)passalt)<0)
  {
    cout << "Reply-Digest stimmt aber nicht !\n";
    cout << "(Wenn das Pawort falsch war, wundere man sich nicht)\n";
  }
  else if(debugflags)
  {
    cout << "Reply-Digest stimmt sogar ! \n";
  }
  if(antwort.code() == PW_PASSWORD_ACK)
  {
    cout << "Pawort erfolgreich gendert !\n";
  }
  else
  {
    cout << "Pawort nderung verweigert !\n";
  }
  cout << "Antwort des radiusd: ";
  if(!debugflags)
  {
    char puffer[256];
    auth_attr *pmattr = antwort.finde(PW_PORT_MESSAGE);
    if(pmattr != NULL)
    {
      getstring(puffer,pmattr);
      cout << puffer;
    }
  }
  else
  {
    cout << '\n';
    antwort.print(cout);
  }
  cout << endl;
}




