/**************************************************************************
 * Programm...: t                                                         *
 * Zweck......: Programm to test RADIUS_authorisation                     *
 * copyright: 1996,1997: Rudolf Weber Ravensburg                          *
 * email: rw@weber.rv.infnet.verein.de                                    *
 * Rights: see GNU-Copyleft (Distribution only with Source-Code)          *
 * Comericial Users are ask to send money                                 *
 **************************************************************************/
#include<iostream.h>
#include<sys/file.h>
#include<sys/time.h>
#include<getopt.h>
#include"logmsg.h"
#include"radius.h"
#include"config.h"
#include"radiusclient.h"
#include"messungen.h"

const int RCVBUF_SIZE=8192;
const int SNDBUF_SIZE=4096;
char recvbuffer[RCVBUF_SIZE];
char sendbuffer[SNDBUF_SIZE];

Attrdict dict;
char *progname;
int debugflags=0;

int main(int argc,char **argv)
{
   Clientconf clientcf;
   char ipadrstring[16];
   char *p;
   int r;
   short port=0;
   int neu = 0;
   int nullpak = 0;
   struct option long_options[] =
   {   {"dict",1,0,1 },
       {"conf",1,0,'c'},
       {"nonrandom",1,0,2},
       {"null",1,0,'0'},
       {0,0,0,0}
   };
   int oi = 0;
   int c;
   char *confpath = defaultclientconfigfile();
   char *dictdir;
   int nr;
   Clientsecurityinfo csi;
   struct sockaddr_in salocal;
   int sockfd;
   struct timeval startkommu,endekommu,dauerkommu;
   u_char proxybit=0;

   progname=argv[0];
   logmsginit(LOGMSG_STDERR,progname,0,0);
   clientcf.readconfig(confpath);
   dictdir=clientcf.dictpath;
   while((c=getopt_long(argc,argv,"H:c:vl:0p",long_options,&oi))!=-1)
   {
       switch(c)
       {
       case 'H':
           {
	     clientcf.addradserver(optarg);
	   }
	   break;
       case 1:
	   dictdir = optarg;
	   cout << "Dict: " << dictdir << endl;
	   break;
       case 2:
           {
	       if(strlen(optarg)==AUTH_VECTOR_LEN)
	       {
		   nr=1;
		   u_char *pz=csi.vector;
		   for(u_char *po=(u_char *)optarg;
		       po<(u_char *)optarg+AUTH_VECTOR_LEN;*pz++=*po++);   
	       }
	       else
	       {
		   cerr << "Authorisierungsvektor mu 16 Zeichen lang sein\n";
		   exit(1);
	       }
           }
       case 'c':
	 confpath = optarg;
	 clientcf.readconfig(confpath);
	 dictdir=clientcf.dictpath;
	 break;
       case 'v':
	   cout << "Rudolfs neue Version \n";
	   break;
       case '0': 
	 cout << "sende Null-Paket ....\n";
	 nullpak = 1;
	 break;
       case 'p': // Anfrage als proxy
	 proxybit=PW_RW_PROXY_BIT;
	 break;
       default:
	   cerr << "Unbekannte Option " << c << endl;
       }
   } 

   dict.init(dictdir);

   char username[256];
   char username_realm[256];
   char *realm;
   char password[AUTH_PASS_LEN+1];
   char cryptpw[AUTH_PASS_LEN];
   char userservice[32];
   char framedprotokoll[32];
   Attreintrag *service = dict[PW_USER_SERVICE_TYPE];
   Attreintrag *framedp = dict[PW_FRAMED_PROTOCOL];
   int passlen;
   struct sockaddr_in absenderadr;
   Zusenden ar(sendbuffer,SNDBUF_SIZE);
   Empfangen antwort(absenderadr,recvbuffer,RCVBUF_SIZE);


   cout << "User ?"; cin >> username;
   cout << "Pawort ?";cin >> password;
   cout << "Userservice ?";cin >> userservice;
   framedprotokoll[0]='\0';
   if(strstr(userservice,"Framed")!=NULL)
   {
     cout << "Framed-Protokoll ?"; cin >> framedprotokoll;
   }
   /* 
    * for RADIUS we login in as username@realm eventualy so
    * here we add an @realm part of username if not already
    * specified.
    */
 
   strncpy(username_realm, username, sizeof(username_realm));
   
   realm = strchr(username_realm, '@');
   /* Append default realm */
   if(realm == NULL)
   {
     if(clientcf.default_realm && (*(clientcf.default_realm)) != '\0')
     {
       strncat(username_realm, "@", sizeof(username_realm));
       strncat(username_realm, clientcf.default_realm, sizeof(username_realm));
       realm = clientcf.default_realm;
     }
     else realm = ""; 
   }
   else 
   {
     realm++; // vernichte @
   }
   sockfd = opensocket(salocal);
   salocal.sin_addr = myaddr();
   
   csi.secret = clientcf.secinf.secret(salocal.sin_addr,realm);
   if(csi.secret == NULL)
   {
     cerr << "Keine Erlaubnis fr realm " << realm << endl;
     exit(1);
   }

   cout <<  "Absender " << salocal
#ifdef DEBUG
        <<  " Secret: " << csi.clinfo->secret
#endif
        << endl;
   if(!nr) random_vector(csi.vector);
   

   ar.initsend(PW_AUTHENTICATION_REQUEST|proxybit,(u_char)seqnr(clientcf.seqfile),csi.vector);
   ar.addattr(PW_USER_NAME,username_realm,strlen(username_realm));
  
   ar.calc_digest(csi.secret);
   passlen = strlen(password);
   ciffrepassword((u_char *)cryptpw,(u_char *)password,passlen,ar.getdigest());
   ar.addattr(PW_PASSWORD,cryptpw,passlen);
   ar.addattr(service,userservice);
   if(framedprotokoll[0]!='\0')
   {
     ar.addattr(framedp,framedprotokoll);
   }
   cout << "zu sendende Anforderung:\n";
   ar.print(cout);

   gettimeofday(&startkommu,NULL);
   if(!komuwithserver(sockfd,ar,antwort,clientcf.radhosts,csi,clientcf))
   {
     cerr << "Anfrage ist Fehlgeschlagen \n";
     exit(1);
   }
   gettimeofday(&endekommu,NULL);
   timeval_subtract(&dauerkommu,&endekommu,&startkommu);
   cout << "Erhaltene Rckmeldung:\n";
   antwort.print(cout);
   cout << "\nKommunikationsdauer: " << timeval2double(&dauerkommu)
	<< " (" << dauerkommu.tv_sec << " s " 
	<< dauerkommu.tv_usec << " us)\n";
}














