
/*
 * $Id: clientid.c,v 1.8 1996/09/15 11:36:29 lf Exp $
 *
 * Copyright (C) 1995 Lars Fenneberg
 *
 * See the file COPYRIGHT for the respective terms and conditions. 
 * If the file is missing contact me at lf@elemental.net 
 * and I'll send you a copy.
 *
 */

#include <sys/types.h>
#include<iostream.h>
#include <stdio.h>
#include <ctype.h>
#include <string.h>
#include <errno.h>
#include <stdlib.h>
#include"logmsg.h"
#include "config.h"
#include "radius.h"
#include"ttyidmap.h"

/*
 * Method: lese
 *
 * Purpose: Read in the ttyname to port id map file
 *
 * Arguments: the file name of the map file
 *
 * Returns: zero on success, negative integer on failure 
 */

int Ttyidmap::lese(char *filename)
{
  char buffer[1024];
  FILE *mapfd;
  char *c, *name, *id, *q;
  ttyid **akt=&wurzel;
  int lnr = 0;
  
  if ((mapfd = fopen(filename,"r")) == NULL)
  {
    logmsg(LOG_ERR,"Ttyidmap: can't read %s: %s", filename, strerror(errno));
    return (-1);
  }
	
#define SKIP(p) while(*p && isspace(*p)) p++;

  while (fgets(buffer, sizeof(buffer), mapfd) != NULL)
  {
    lnr++;
        
    q = buffer;
    
    SKIP(q);
    
    if ((*q == '\n') || (*q == '#') || (*q == '\0'))
      continue;
    
    if (( c = strchr(q, ' ')) || (c = strchr(q,'\t')))
    {
      *c = '\0'; c++;
      SKIP(c);
      
      name = q;
      id = c;
      
      if ((*akt = new ttyid(name,atoi(id))) == NULL)
      {
	logmsg(LOG_CRIT,"ttyid::lese : out of memory");
	return (-1);
      }
      akt = &((*akt)->next); 
    }
    else
    {
      logmsg(LOG_ERR, "rc_read_mapfile: malformed line in %s, line %d", filename, lnr);  
      return (-1);
      
    }
  }
  
#undef SKIP

  fclose(mapfd);
  
  return 0;
}

/*
 * operator []
 *
 * Purpose: Map ttyname to port id
 *
 * Arguments: full pathname of the tty
 *
 * Returns: port id, zero if no entry found
 */
#ifndef PATH_MAX
#define PATH_MAX       1024
#endif

UINT4 Ttyidmap::operator[](char *name)
{
  ttyid *p;
  char ttyname[PATH_MAX];
  
  *ttyname = '\0';
  if (*name != '/')
    strcpy(ttyname, "/dev/");
  
  strncat(ttyname, name, sizeof(ttyname));
	
  for(p = wurzel; p; p = p->next)
    if (!strcmp(ttyname, p->name)) return p->id;
  
  logmsg(LOG_WARNING,"Ttyidmap[]: can't find tty %s in map database", ttyname);
  
  return 0;
}


