/**********************************************************************
 * Headerfile...: admin_realm.h                                       *
 * Zweck........: Der Administrationsrealm soll folgende Sachen       *
 *                behandeln:                                          *
 *                - CLID-Clid-Authorisierung                          *
 *                - Behandlung von Anforderungen ohne PW_USER_NAME    *      
 *                - route - Anforderungen                             *
 *                - weitergabe von realm-Losen sachen an den          *
 *                  Default-Realm                                     *
 * Author.......: Rudolf Weber Informatikberatung Ravensburg 1998     *
 * Copyright....: GNU_Copyleft                                        *
 **********************************************************************/
#ifndef ADMIN_REALM_H
#define ADMIN_REALM_H
#include<assert.h>
#include<string.h>
#include"realms.h"
#include<db_cxx.h>
#include"routetab.h"
#include"clients.h"
class Admin_realm: public Realm
{
protected:
  Routetab routetab;
public:
  Admin_realm(const char *name):Realm(name)
    { assert(strcmp(name,"admin")==0); }
  int init(char *parameterstr);
  int anfang();
  int ende();
  void initaktionen(); 
  //Aktionen
  int radauthenticate(int sockfd,Empfangen &msg,Zusenden &antwort);
 
  static int radauthenticate(Realm *r,int sockfd,Empfangen &msg,Zusenden &antwort);
  static int accounting(Realm *r,int sockfd,Empfangen &msg,Zusenden &antwort);
  static int passchange(Realm *r,int sockfd,Empfangen &msg,Zusenden &antwort);
#ifdef RADADMINCOMPAT
  static int adminrequest(Realm *r,int sockfd,Empfangen &msg,Zusenden &antwort);
#endif
  int authclid(char *clid,int sockfd,Empfangen &msg,Zusenden &antwort);
  int administrativequery(char *user,int sockfd,Empfangen &msg,Zusenden &antwort,const Clientinfo *clinfo);
};
#endif
