#ifndef AUTH_H
#define AUTH_H
#include"radius.h"
const char UNIX_PWD[]="UNIX";

/***************************************************************************
 * Passwortauthorisierung fr PAP und CHAP                                 *
 * Parameter:                                                              *
 *    clearpwd : das aus der radiusmsg decodierte PASSWD                   *
 *    authpwd:   das Authorierungsattribut                                 *
 *    dbpwt:     Typ des Passworts in dbpwd                                *
 *                 C: Klartext (bei CHAP einzig mglich )                  *
 *                 Y: mit crypt codiert                                    *
 *                 U: hole dbpwd ist der Unixnutzer, UNIX-Abfrage          *
 *    dbpwd:     das Passwort aus der Datenbank/Nuzer fr pwdt==B          *
 *    dbpwdlen: Lnge des passwds                                          *
 *    msg     : Die radius-nachricht (ntig fr Informationen bei CHAP)    *
 *    portmsg : Rckgabefehlermeldung                                      *
 * liefert:                                                                *
 *    1: falls Passwd richtig                                              *
 *    0: falls passwd falsch ober fehler                                   *
 ***************************************************************************/
int auth_pass(const char *&portmsg,auth_attr *authpwd,char *clearpwd,char dbpwt,char *dbpwd,int dbpwlen,Empfangen& msg);
const char *unix_pass(char *name,char *passwd);

// liefert: NULL falls versuch = passwd
//          sonst eine Fehlermeldung
const char *passcheck(char *versuch,char pwt,char *passwd,int pwlen);

// Zur neucodierung eines gekypteten Passworts
char *cryptpw(char *pw);
/***************************************************************************
 * Prft Time-Out-zeit
 * Parameter: expt : Expirtetime in Sekunden seit 1.1.1970
 ***************************************************************************/
int auth_check_timeout(const char *&portmsg,long expt);
#endif
