/*********************************************************************
 * Modul...: clients.cc                                              *
 * Zweck...: Verwaltet Clienttabelle                                 *
 * Bemerkung: Eigendlich sollte dies von einer Standarttemplate      *
 *            gemacht werden.                                        *
 *            Aber: ich bin zu faul, eine zu suchen                  *
 *            oder eine zu bastln                                    *
 *********************************************************************/
#include<netdb.h>
#include<stdio.h>
#include<iostream.h>
#include"conf.h"
#include"clients.h"
#include"ipaddrtools.h"
#include"logmsg.h"
#include"errmsg.h"
#include"cache/usersparse.h"

class Clientsscanner: public Userservicescanner
{
protected:
public:
  Clientsscanner(Attrdict &dict):Userservicescanner(dict) {}
  int Scankopf(Clientinfo &ci);
  int parseclient(Clientinfo &ci);
};

int Clientsscanner::Scankopf(Clientinfo &ci)
{
  int r;
  char *pz;
  u_char *upz;
  struct in_addr hipaddr;
  struct hostent *hp;

  while((r=nextline())!=ENDE && r!=BEGINNZEILE);
  if(r==ENDE) return r;

  pz=ci.hostname;
  while(!isspace(*p) && *p!='@') *pz++=*p++;
  *pz='\0';
  if(pz-ci.hostname < 1)
  {
    error("kein Recher angegeben");
    return ERROR;
  }
  if(parseipaddr(hipaddr,ci.hostname)>=0)
  {
    ci.ipaddr.s_addr = hipaddr.s_addr;
  }
  else
  {
    if((hp = gethostbyname(ci.hostname)) != NULL)
    {
      ci.ipaddr.s_addr = *(UINT4 *)(hp->h_addr);
    }
    else
    {
      error("ungltiger Rechner");
      return ERROR;
    }
  }
  /* realm */
  if(*p=='@')
  {
    pz=ci.realm;
    p++; // @ ueberlesen
    while(!isspace(*p)) *pz++=*p++;
    *pz='\0';
  }
  else
  {
    strcpy(ci.realm,"*");
  }
  eatwhite();
  
  /* Secret */
  upz=ci.secret;
  while(!isspace(*p)) *upz++=*p++;
  *upz='\0';
  if(upz-ci.secret < 4)
  {
    error("Secret nicht vorhanden oder zu kurz");
    return ERROR;
  }
  return OK;
}

int Clientsscanner::parseclient(Clientinfo &ci)
{
   char buf[1024];
   Cacherecverw crv(buf,1024);
   int r;

   if((r=Scankopf(ci))!=OK) return r;
   if((r=parsedienste(&crv))!=OK) return r;
   
   ci.defattr = (Cacherecord *)malloc(crv.totallen());
   memcpy((u_char *)(ci.defattr),crv.data(),crv.totallen());
   return OK;
}

const char *Clients::init(char *datname,Attrdict &dict)
{
  Clientsscanner cscan(dict);
  Clientinfo  ein;
  liste **einf = NULL;
  int r;
  cscan.init(datname);

  while((r=cscan.parseclient(ein))!=ENDE)
  {
    if(r==OK)
    {
      liste *h=NULL;
      einf = suche(ein.ipaddr);
      if(*einf != NULL) h=*einf;
      *einf = new liste(ein);
      (*einf)->next=h;
    }
  }
}

Clients::liste **Clients::suche(struct in_addr ipa)
{
  liste **akt = &wurzel;
  while(*akt != NULL && (*akt)->in.ipaddr.s_addr < ipa.s_addr)
    akt = &((*akt)->next);
  return akt;
}

const Clientinfo *Clients::finde(struct in_addr ipa,const char *realm)
{
  register int r;
  liste *akt = *suche(ipa);
  if(akt == NULL || akt->in.ipaddr.s_addr != ipa.s_addr)
  {
    return (Clientinfo *)0;
  }
  while(akt != NULL && akt->in.ipaddr.s_addr == ipa.s_addr && 
        !(r=(strcmp(akt->in.realm,"*")==0 || strcmp(akt->in.realm,realm)==0)))
    akt = akt->next;
  return (akt != NULL && akt->in.ipaddr.s_addr == ipa.s_addr && r
	  ? (Clientinfo *)akt
	  : (Clientinfo *)0);   
}

const u_char *Clients::secret(struct in_addr ipa,const char *realm)
{
  const Clientinfo *erg;
  erg = finde(ipa,realm);
  return (erg != (Clientinfo *)0 ? erg->secret : (u_char *)0);
}

#ifdef CLIENTS_TEST
#include"config.h"
Attrdict dict;
Clients clients;
char *progname;
int debugflags = 0;

int main(int argc,char **argv)
{
    const Clientinfo *t;
    struct in_addr ipa;
    Attreintrag *service;
    Attreintrag *proto;
    char buf[64];

    progname=argv[0];
    dict.init(RADDICT);
    service =  dict[PW_USER_SERVICE_TYPE];
    proto   =  dict[PW_FRAMED_PROTOCOL];
    logmsginit(LOGMSG_STDERR,argv[0],0,0);
    if(argc < 2)
    {
      logmsg(LOG_ERR,"Aufruf: %s <clientstext>",argv[0]);
      exit(1);
    }
    clients.init(argv[1],dict);

    cout << "IP ?";
    
    for(cin>>buf;cin;cin>>buf)
    {
      cout << buf;

      if(parseipaddr(ipa,buf)<0)
      {
	cerr << "Ip-Adresse erwartet !!!!";
	continue;
      }
      cout << endl << "Realm ?";
      cin >> buf;
      if(!cin) continue;
      if(buf[0]=='\0') 
      {
	buf[0]='*';buf[1]='\0';
      }
      t = clients.finde(ipa,buf);
      if(t!=NULL)
      {
	UINT4 dienstnr;
	Cacherecverw def;
	char *p;
	const char *err;
	CRDienst *d;

	cout << t->hostname << " " << t->realm << " " << t->secret << endl;
	cout << "Dienst ?";
	cin >> buf;
	if(!cin) continue;
	p=buf;
	err = parsedienst(dienstnr,p,service,proto);
	if(err)
	{
	  cerr << err << endl;
	  continue;
	}
	def.setbuffer(t->defattr);
	if((d=def.findedienst(dienstnr))!=NULL)
	{
	  for(auth_attr *akt=def.first(d);akt!=NULL;akt=def.next())
	  {
	    akt->print(cout);cout << '\n';
	  }
	  cout << endl;
	}
	else
	{
	  cout << "Dienst nicht zugelassen \n";
	}
      }		       
      else cout << "Host nicht gefunden !\n";
      cout << "IP ?"; 
    }    
}
#endif















