/**************************************************************************
 * Headerfile...: clients.h                                                *
 * Zweck........: Klasse Client verwaltet die Rechner, die anfragen drfen *
 *------------------------------------------------------------------------*
 * copyright: 1997 Rudolf Weber Informatikberatung                        *
 *                 Ravensburg,Germany                                     *
 * email: rw@w-4.de                                                       *
 * Rights: see GNU-Copyleft (Distribution only with Source-Code)          *
 * Comericial Users are ask to send money                                 *
 **************************************************************************/
#ifndef CLIENT_H
#define CLIENT_H
#include"secinf.h"
#include"cache/usercache.h"

struct Clientinfo
{
  struct in_addr ipaddr;
  char hostname[200];
  char realm[56];
  u_char secret[256];
  Cacherecord *defattr; // default-Attribute
};

class Clients : public Secinf
{
private:
  struct liste
  {
    Clientinfo in;
    struct liste *next;
    liste(Clientinfo &e) { in = e; next=NULL; }
  };
  liste *wurzel;
  liste **suche(struct in_addr ipa);
public:
  Clients() { wurzel=NULL; }
  const char *init(char *datname,Attrdict &dict);
  const Clientinfo *finde(struct in_addr ipa,const char *realm="");
  const u_char *secret(struct in_addr ipa,const char *realm="");
};
#endif







