/*************************************************************************
 * Defmodul...: errorclass.h                                             *
 * Zweck......: einfache Fehlerobjecte fr try-throw-catch               *
 * Copyright..: 1998 Informatik- und Netzwerkverein Ravensburg e.V       *
 *              nach GNU-Copyleft                                        *
 * Author.....: Rudolf Weber                                             *
 * Bemerkung..: Stammt aus radiusd                                       *
 *************************************************************************/
#ifndef ERRORCLASS_H
#define ERRORCLASS_H
#include<stdarg.h>
#include<stdio.h>
// Fehlerbehandlungsklassen
class Error
{
protected:
  char errmsg[256];
public:
  Error() {}
  Error(const char *msg) { strncpy(errmsg,msg,255); }
  const char *what() { return errmsg; }
};

class Syntaxerror: public Error
{
public:
  Syntaxerror(const char *m,...):Error()
    {
      va_list args;
      va_start(args,m);
      vsnprintf(errmsg,255,m,args);
      va_end(args);
    };
};

class Databaseerror: public Error
{
  long icode;
public:
  Databaseerror(const char *m):Error(m){};
  Databaseerror(char *dbname,long code,char *m,...):Error() 
    {
      char format[200];
      va_list args;
      va_start(args,m);
      snprintf(format,200,"%s-CODE %ld: %s",dbname,code,m);
      vsnprintf(errmsg,255,format,args);
      va_end(args);
      icode=code;
    }
  long code() const { return icode; }
};
#endif

