/*************************************************************************
 * falle.h.......: Falle fr Verbrecher                                  *
 * Author........: Rudolf Weber Informatikberatung Ravensburg            *
 * Copyright.....: 1997 GNU Copyleft                                     *
 *************************************************************************/
#ifndef FALLE_H
#define FALLE_H
#include"db_cxx.h"

// flags fr init
const int FF_RDONLY=DB_RDONLY;
const int FF_CREATE=DB_CREATE;
const int FF_TRUNCATE=DB_TRUNCATE;

class Falle
{
private:
  char dateiname[80];
  Db *fdb;
public:
  Falle() { dateiname[0]='\0';fdb=(Db *)0; }
  Falle(char *datname,int flags) { init(datname,flags);}
  ~Falle() { if(fdb) fdb->close(0); }
  int init(char *datname,int flags);
  int schreibe(char *name,char *script);
  int aktion(const char *name,int nlen,UINT4 ip,UINT4 event);
  int loesche(char *name);
  int lese(const char *name,int nlen,char *script,int slen);
  close() { fdb->close(0);}
  
  friend class Falleit;
};

class Falleit
{
  Dbc *iterator;
  Dbt key;
  Dbt data;
  int status;
  char *oldptr;
  char user[256];
  char puffer[256];
public:
  Falleit(Falle& f)
    {
      user[0]='\0';
      key.set_data(user);key.set_ulen(256);key.set_flags(DB_DBT_USERMEM);
      data.set_data(puffer);data.set_ulen(256);data.set_flags(DB_DBT_USERMEM);
      f.fdb->cursor(0,&iterator);
      next();
    }
  const char *next() 
    {
      status = iterator->get(&key,&data,DB_NEXT);
      if(status == 0)
      {
	user[key.get_size()]='\0'; 
	puffer[data.get_size()]='\0';
      }
      else
	return (char *)0;
    }                   
  const char *operator()()
    {
      return (status == 0 ? user : (char *)NULL);
    }
  char *script() { return (status==0 ? puffer : (char *)0); }

  ~Falleit()
    {
      iterator->close();
    }
};

void install_sigchldhandler();
#endif






