/***************************************************************************
 * Modul.....: radadmincompat.cc                                           *
 * Zweck.....: Ergnzt Klasse db_realm mit der Operation adminrequest, die *
 *             alte radadmin Anweisungen erledigt.                         *
 * Bemerkung.: radadmin ist obsolet, da die BerklyDB von mehreren Prozessen*
 *             bearbeitet werden kann. Aber MMIMS V0.1 hat ein Msli-      *
 *             programm userver, das bis zum Bau der nchsten MMIMS-version*
 *             nicht weggeschmissen werden kann.                           *
 * Author....: Rudolf Weber Informatikberatung Ravensburg                  *
 * Copyright.: 1998 GNU                                                    *
 ***************************************************************************/
#include<iostream.h>
#include<string.h>
#include<stdlib.h>
#include<unistd.h>
#include<errno.h>
#include<sys/time.h>
#include<ctype.h>
#include<syslog.h>
#include"radius.h"
#include"md5.h"
#include"auth.h"
#include"db_realm.h"
#include"clients.h"
#include"userrecord.h"

extern Attrdict dict;
extern Clients  clients;

int Db_realm::adminrequest(Realm *r,int sockfd,Empfangen &msg,Zusenden &antwort)
{
    extern int debugflags;
    char *portmsg = NULL;      
    char errmsg[256];
    char user[256];
    char realm[256];
    char altpuffer[4096];
    char neubuffer[4096];
    Cacherecverw alt(altpuffer,4096);
    Cacherecverw neu(neubuffer,4096);
    Userrecverw mur; // Userrecord in msg
    Db_realm *dr=(Db_realm *)r;
    UINT4 dnr = 0;
    // der Default und bisher nur dies vorgesehen
    mergeservice(dnr,PW_FRAMED_USER);  
    mergeproto(dnr,PW_PPP);
    char absenderipstr[32]; 
    iptostr(absenderipstr,msg.getabsender().sin_addr);   

    auth_attr *akt = msg.first();
    
    if(akt->id != PW_USER_NAME) 
    { 
      if(debugflags) cerr << "Falsches adminrequestpaket von" << absenderipstr;
      syslog(LOG_ERR,"Falsches adminrequestpaket von %s ",absenderipstr);
      return -1;
    }
    
    getuserandrealm(user,realm,akt);

    if(msg.authenticate(&clients,realm)<0)
    {
       if(debugflags) cerr << "Falsches Digest von" << absenderipstr;
       syslog(LOG_ERR,"Falsches Digest von %s ",absenderipstr);
       return -1;
    }

    akt = msg.next();
    if(akt!=NULL && akt->id != PW_RW_USER_RECORD)
    {
      if(debugflags) cerr << "Falsches adminrequestpaket von" << absenderipstr;
      syslog(LOG_ERR,"Falsches adminrequestpaket von %s ",absenderipstr);
      return -1;
    }
    if(msg.code() == PW_RW_NEWUSER_REQUEST)
    {
        int ok=0;
	// einfach in die Tabelle eintragen ohne Rcksicht auf Verluste
	mur.setbuffer((char *)(akt->data));
	mur.ntoh();
	neu.clear();
        neu.neuerdienst(0);
        // Kopiere die check-Attribute und kontrolliere ob passwd vorhanden
        for(auth_attr *a=mur.firstcheck();a!=NULL;a=mur.nextcheck())
	{
	  if(a->id == PW_PASSWORD || a->id == PW_CHAP_PASSWORD) ok=1;
	  neu.add(a);
	}
	if(!ok)
	{
	
	  if(debugflags) 
	  {
	    cerr << "Kein Password in adminrequest von" << absenderipstr
		 << "fr " << user << endl;
	  }
	  syslog(LOG_ERR,"Kein Password in adminrequest von %s fr Nutzer %s",
		 absenderipstr,user);
	  return -1;
	}
	// Kopiere die reply-Attribute
	neu.neuerdienst(dnr); // Immer der selbe - wir sind etwas dumm und faul
	neu.addm(mur.firstreply(),mur.lenreply());

	try
	{
	  dr->db.schreibe(user,&neu);
        }
	catch(DbException &dbe)
	{
	  syslog(LOG_ERR,"db-Fehler: %s",dbe.what());
	  sprintf(errmsg,"Interner DB_Fehler %s",dbe.what());
	  portmsg = errmsg;
	  ok=0;
	}
	if(debugflags) 
	{ 
	  cout << "User " << user << " eingetragen. Datensatz:\n";
	  neu.print(cout);
	}
	syslog(LOG_NOTICE,"Nutzer %s von %s mit adminrequest angelegt",
	       user,absenderipstr);
    }
    else if(msg.code() == PW_RW_USERUPD_REQUEST)
    {
      mur.setbuffer((char *)(akt->data));
      mur.ntoh();
      neu.clear();
      try
      {
	if(dr->db.lese(user,strlen(user),&alt)>=0)
	{
	    
	  /* Kopiere die empfangenen in die neuen und von den alten die
             nicht in den Empfangenen sind
             1. Fr die check-Attribute
	   */
	  neu.mcopyreplace(mur.firstcheck(),mur.lencheck(),0,&alt);
	  
          /* 2. fr Framed-User/PPP */
	  neu.mcopyreplace(mur.firstreply(),mur.lenreply(),dnr,&alt);
	  /* 3. kopiere alle anderen Dienste */
	  for(CRDienst *ad=alt.ersterdienst();ad!=NULL;ad=alt.weitererdienst())
	  {
	    if(ad->dienst==0 || ad->dienst==dnr) continue;
	    neu.copydienst(ad,&alt);
	  }
	  dr->db.schreibe(user,&neu);
	  syslog(LOG_NOTICE,"radadminrequest von %s betreffs Nutzer %s",
		 absenderipstr,user);
	  if(debugflags) 
	  { 
	    cout << "User " << user << " gendert. nderung:\n";
            mur.print(cout);
            cout << "Datensatz:\n";
	    neu.print(cout);
	  }
	}
	else
	{
	  sprintf(errmsg,"Nutzer %s nicht vorhanden",user);
	  portmsg=errmsg;
	  if(debugflags) cout << portmsg << endl;
	  goto newusererror; // Fehlerbehandlung
	}
      }
      catch(DbException &dbe)
      {
	syslog(LOG_ERR,"db-Fehler: %s",dbe.what());
	sprintf(errmsg,"Interner DB_Fehler %s",dbe.what());
	return -1;
      }
    }
    else if(msg.code() == PW_RW_NEWUSER_REJECT)
    {
      try
      {
	if(dr->db.loesche(user)<0)
	{
	    if(debugflags) cout << "Nutzer " << user << " war nicht vorhanden!\n";
            goto newusererror;
	}
      }
      catch(DbException &dbe)
      {
	syslog(LOG_ERR,"db-Fehler: %s",dbe.what());
	sprintf(errmsg,"Interner DB_Fehler %s",dbe.what());
	return -1;
      }
      if(debugflags) cout << "Nutzer " << user << " eliminiert !!!\n";
    }
    
    antwort.initsend(PW_RW_NEWUSER_ACT,msg.id(),msg.getvector());
    
    antwort.calc_responsedigest(msg.getsecret());
    if(debugflags) antwort.print(cout);
    antwort.send(sockfd,msg.getabsender());
    return 0;
    
newusererror:    
    if(debugflags) cout << "Anforderung abgelehnt !\n";
    antwort.initsend(PW_RW_NEWUSER_REJECT,msg.id(),msg.getvector());
    if(portmsg)
    {
      antwort.addattr(PW_PORT_MESSAGE,portmsg,strlen(portmsg));
    }
    antwort.calc_responsedigest(msg.getsecret());
    if(debugflags) antwort.print(cout);
    antwort.send(sockfd,msg.getabsender());
    return 0;
}


