/***********************************************************************
 * Headerfile....: radlog.h                                            *
 * Zweck.........: definiert Klassen zum Loggen von Radiuspaketen      *
 * Author........: Rudolf Weber Ravensburg                             *
 * Copyright.....: 1998 Informatik- und Netzwerkverein Ravensburg.e.V  *
 *                 GNU-Copyleft                                        *
 ***********************************************************************/
#ifndef RADLOG_H
#define RADLOG_H
//#include<fstream.h>
#include<signal.h>
#include<stdarg.h>
#include"dict.h"
#include"nachricht.h"

class Logspez
{
    Attreintrag *in[20];
    Attreintrag **akt;
    
public:
    Logspez() {}
    void init(char *datname);
    Attreintrag *first() { akt = in; return *akt; }
    Attreintrag *next()  { return ((*akt != NULL) ? *(++akt)
				                  : (Attreintrag *)NULL);
			   
		         }
    
};

class Logpuffer
{
public:
  char puffer[1024];
  int lang;

  Logpuffer() { init(); }
  init();
  ende();
  schreib(int fd);
  int maxlen() { return 1024; }

};

class Logfile
{
protected:
  int fd;
  sigset_t sigmask,oldsigmask;
  char *logfilename;  
  Logpuffer lp;
  
  int lock();
  int unlock();
public:
  int begin();
  int end();
  int init(char *datname) { logfilename = datname; fd=-1;}
  int logstr(const char *format,...);
  virtual log(Nachricht& msg)=0;
  int reinit() { end();begin(); }          // fuer SIGHUP oder so
};

class FieldLogfile : public Logfile
{
protected:
  Logspez *spez;
  
public:
  int init(Logspez &ls,char *datname);
  int log(Nachricht& msg);
};

class PaketLogfile : public Logfile
{
public:
  int log(Nachricht& msg);
};

enum PaketLoglevel { PLL_NONE,PLL_ALL,PLL_AUTH,PLL_ADMIN,PLL_WRONGPW };

int parsepaketloglevel(PaketLoglevel& pll,char *level);

#endif






