/*********************************************************************
 * Modul........: realm.cc                                           *
 * Zweck........: Gemeinsames fr alle Realms                        *
 * Autor........: Rudolf Weber Informatik Beratung Ravensburg        *
 * Copyright....: 1997 GNU-License                                   *
 *********************************************************************/
#include<string.h>
#include<syslog.h>
#include"realms.h"
#include"radlog.h"
#include"falle.h"
#include"clients.h"

extern Clients clients;
extern int debugflags;

Realm::Realm(const char *pname)
{
  strncpy(iname,pname,REALM_NAMELEN); 
  memset((char *)aktionen,'\0',64*sizeof(Raktion));
  nxt=NULL;
}

Realm::ende()
{
  if(debugflags)
  {
    cerr << "Beende Realm " << name() << endl; 
  }
}

Raktion Realm::aktion(int a)
{
  a &= ~PW_RW_PROXY_BIT;
  return ( 0 <=a && a<64 ? aktionen[a] : (Raktion)0);
}

int Realm::radauthenticate(int sockfd,Empfangen &msg,Zusenden &antwort)
{
  return -1;
}

int Realm::accounting(int sockfd,Empfangen &msg,Zusenden &antwort)
{
    extern int debugflags;
    // Benutze globales logfile und Falle
    extern FieldLogfile log;
    extern Falle   falle;
    extern int fang;

    char user[256];
    char realm[256];
    auth_attr *userattr;

    realm[0]='\0';
    user[0]='\0';
    if((userattr=msg.finde(PW_USER_NAME))!=NULL)
    {
      getuserandrealm(user,realm,userattr);
    }  

    if(msg.authenticate(&clients,name())<0)
    {
        char absenderipstr[32]; 
        iptostr(absenderipstr,msg.getabsender().sin_addr);
	if(debugflags) cerr << "Falsches Digest von" << absenderipstr;
        syslog(LOG_ERR,"Falsches Digest von %s ",absenderipstr);
	return -1;
    }
    log.log(msg);
    antwort.initsend(PW_ACCOUNTING_RESPONSE,msg.id(),msg.getvector());
    antwort.calc_responsedigest(msg.getsecret());
    if(debugflags) antwort.print(cout);
    antwort.send(sockfd,msg.getabsender());
    
    if(fang && userattr !=NULL)
    {
      auth_attr *eventattr;
      auth_attr *ipattr;

      if(realm[0]=='\0')
      {
	strcat(user,"@");
	strcat(user,name());
      }
      else
      {
	getstring(user,userattr);
      }
      eventattr = msg.finde(PW_ACCT_STATUS_TYPE);
      ipattr    = msg.finde(PW_FRAMED_ADDRESS);
      if(eventattr!=NULL && ipattr!=NULL)
      {
	falle.aktion(user,strlen(user),*(UINT4 *)(ipattr->data),getintval(eventattr));
      }
      else
      {
	syslog(LOG_WARNING,"Falle %s zugeschnappt aber IP oder Event fehlt",user);
      }
    }
}

int Realm::passchange(int sockfd,Empfangen &msg,Zusenden &antwort)
{
  return -1;
}




