/*********************************************************************
 * Headerfile...: realms.h                                           *
 * Autor........: Rudolf Weber Informatik Beratung Ravensburg        *
 * Copyright....: 1997 GNU-License                                   *
 *********************************************************************/
#ifndef REALMS_H
#define REALMS_H
#include<iostream.h>
#include"radius.h"
#include"errorclass.h"

const int REALM_NAMELEN=30;

/*------- Ablehnungsgrnde --------*/
const int RJ_UNKNOWN_CLIENT=-1;
const int RJ_NO_PASSWD=-2;
const int RJ_NO_SERVICE=3;
const int RJ_WRONG_PASSWD=-4;
const int RJ_USER_TIMEOUT=-5;
const int RJ_USER_NOT_FOUND=-6;
const int RJ_REALM_NO_SERVICE=-7;
const int RJ_USER_NO_SERVICE=-8;
const int RJ_CHECK_DONT_MATCH=-9;
const int RJ_INTERNAL_ERROR=-99;


// Nun kommt die Mutter aller Realms
class Realm;

typedef int (*Raktion)(Realm *r,int s,Empfangen& e,Zusenden& z);

class Realm
{
protected:
  char iname[REALM_NAMELEN];
  Raktion aktionen[64];
public:
  Realm(const char *name);
  const char *name() { return iname; }
  virtual int init(char *parameterstr)=0; // Interpretation der Parameter
  virtual int anfang()=0;                 // ffnen der DB, in allen Threads
  virtual int ende(); // Zur Beendigung ....
  Raktion aktion(int a); 
  // Aktionen knnen auch wiederverwendet werden ....
  virtual int radauthenticate(int sockfd,Empfangen &msg,Zusenden &antwort);
  virtual int accounting(int sockfd,Empfangen &msg,Zusenden &antwort);
  virtual int passchange(int sockfd,Empfangen &msg,Zusenden &antwort);
public:
   Realm *nxt;
};

class Realms
{
  Realm *wurzel;
  Realm *admin;
  // fr Parsing
  char datei[100];
  int zeile;
protected:
  Realm *openrealm(const char *name,const char *typ,char *parameter);
public:
  Realms() { wurzel=NULL; admin=NULL; }
  int init(char *path,char *realmdat);
  int anfang();
  int ende();
  Realm* operator[](char *name);
  const char *defaultrealm() { return (wurzel != NULL ? wurzel->name() : ""); }
  Realm *getdefaultrealm() { return wurzel; }
  Realm *getadminrealm() { return admin; }
};


#endif



