
#include<iostream.h>
#include<db_cxx.h>
#include<string.h>
#include<logmsg.h>
#include"routetab.h"


int Routetab::open()
{
  int ret;
  DbInfo dbinfo;
  try
  {
    ret=Db::open(datname,DB_UNKNOWN,DB_RDONLY,0,(DbEnv *)NULL,&dbinfo,&db);
    status=1;
  }
  catch(DbException &dberr)
  {
    logmsg(LOG_ERR,"Db_error: %s",dberr.what());
    status=0;
    return -1;
  }
  return ret;
}

void Routetab::close()
{
  db->close(0);
  status=0;
}

int Routetab::read(char *routeno,int rnl,char *erg,int ergl)
{
  int r=0;
  Dbt key(routeno,rnl);
  Dbt data;
  data.set_data(erg);
  data.set_ulen(ergl);
  data.set_flags(DB_DBT_USERMEM);

  if(!status) r=open();
  if(r<0) return -1;
  
  try
  {
    r = db->get(0,&key,&data,0);
    if(r==0)
    {
      erg[data.get_size()]='\0';
      return 1;
    }
    else if(r==DB_NOTFOUND)
    {
      close();
      return 0;
    }
    else
    {
      close();
      return -1;
    }

  }
  catch(DbException &dberr)
  {
    logmsg(LOG_ERR,"Db_error: %s",dberr.what());
    close();
    return -1;
  }
}

#ifdef ROUTETABMAIN
int main(int argc,char **argv)
{
  char puffer[1024];
  Routetab routetab;
  int r;

  logmsginit(LOGMSG_STDERR,argv[0],0,0);
  routetab.init("/local/radius-0.6/db/route.db");

  r=routetab.read(argv[1],strlen(argv[1]),puffer,1024);
  if(r==1) 
  {
    char *tok;
    for(tok=strtok(puffer,";");tok!=NULL;tok=strtok(NULL,";"))
    {
      cout << tok << endl;
    }
  }
  else if(r==0) cerr << "Ende" << endl;
  else cerr << "Error" << endl;
  
}
#endif
