#ifndef GETEILTES_FELD_H
#include<assert.h>
#include<sys/ipc.h>
#include<sys/shm.h>

template<class FE,class VERW> class GeteiltesFeld
{
  int shmid;
  int anz;
  int blockgr;
  char *segptr;
  int anleger;
public:
  GeteiltesFeld(int panz,int pblockgr,key_t key)
  {
    int gross = (panz+1)*pblockgr;
    blockgr=pblockgr;
    anz=panz;
    anleger=0;
    assert(sizeof(VERW)<=pblockgr);
    assert(sizeof(FE)<=pblockgr);

    if((shmid = shmget(key,gross,IPC_CREAT|IPC_EXCL|0660))<0)
    {
      if(errno == EEXIST)
      {
	cerr << "Unser Segment " << key << " existiert schon ..." << endl;
	shmid = shmget(key,0,0);
      }
      if(shmid<0)
      {
	cerr << "Speichersegment kann nicht angelegt werden: " 
	     << strerror(errno) << endl;
	exit(1);
      }
    }
    else
    {
      anleger=1;
    }
    if((segptr=shmat(shmid,0,0))== (char *)(-1))
    {
      cerr << "Speichersegment kann nicht attacht werden: "
	   << strerror(errno) << endl;
      exit(1); 
    }
  }
  ~GeteiltesFeld()
  {
    shmdt(segptr);
    if(anleger)
    {
      shmctl(shmid,IPC_RMID,NULL);
    }
  }
  int soll_vorbelegung() { return anleger; } // 1: initialisieren
  void clear_anleger() { anleger=0; }        // nach fork im Sohn
  VERW *verwdat() { return (VERW *)segptr; }
  char *anf() { return segptr+blockgr; }
  FE& operator[](int i)
  {
    assert(i <anz);
    return *((FE *)(segptr+(1+i)*blockgr));
  }
  int getanz() { return anz; }
};

#endif




