/**************************************************************************
 * Definitionsmodul: ls2labfeld.h                                         *
 * Zweck...........: Geteilte Blockliste mit LeserSchreiber2 Koordination *
 * Autor...........: Rudolf Weber Informatikberatung                      *
 * Copyright.......: 1998 Informatik- und Netzwerkverein Ravensburg e.V   *
 **************************************************************************/
#ifndef LS2LABFELD_H
#define LS2LABFELD_H
#include"semver.h"
#include"labfeld.h"

class LS2Labfeld : public Labfeld
{
protected:
  Leserschreiber2 sem;

public:
  LS2Labfeld(void *bf,size_t pblockgr,Labfeld_gemein *pg,SemBM &bm,int ml):
    Labfeld(bf,pblockgr,pg),sem(bm,ml)
  {
  }
  LS2Labfeld(void *bf,Labfeld_gemein *pg,SemBM &bm,int ml):
    Labfeld(bf,pg),sem(bm,ml)
  {
  }
  void ausketten(index_t pos)
  {
    sem.schr_beg();
    Labfeld::ausketten(pos);
    sem.schr_end();
  }
  index_t letztes_ausketten()
  {
    // Damit niemend anders mir das letze wegnimmt, mu das Ende innerhalb
    // des geschzten Bereiches geschehen
    index_t ret;
    sem.schr_beg();
    ret=letztes();  
                    
    if(ret != INDEX_ENDE)
    {
      Labfeld::ausketten(ret);
    }
    sem.schr_end();
    return ret;
  }

  void ananfang(index_t pos)
  {
    sem.schr_beg();
    Labfeld::ananfang(pos);
    sem.schr_end();
  }
  void ansende(index_t pos)
  {
    sem.schr_beg();
    Labfeld::ansende(pos);
    sem.schr_end();
  }
  void lese_beg() { sem.lese_beg(); }
  void lese_end() { sem.lese_end(); }
};
#endif










