/*******************************************************************
 * Multthreadet Vorstudie fr Radius                               *
 *******************************************************************/
#include<iostream.h>
#include<signal.h>
#include<stdio.h>
#include<string.h>
#include"logmsg.h"
#include"debug.h"
#include"mlsverw_allg.h"


struct vorst_feldelement : feldelement
{
  int aufnr;
};

int vglauftragsnr(const vorst_feldelement& e1,const vorst_feldelement& e2)
{
  return e1.aufnr == e2.aufnr;
}

int empfange_auftrag(vorst_feldelement &f,void *vp)
{
  cerr << "Meister: Auftragsnummer?" << endl;
  cin >> f.aufnr;

  return ( f.aufnr > 0 ? 0 : -1 );
}


char *schreibe_auftragsnr(char *puffer,vorst_feldelement &f)
{
  sprintf(puffer,"%d",f.aufnr);
  return puffer;
}

void fertigerauftrag(vorst_feldelement &f,void *vp)
{
  cerr << "Auftrag " << f.aufnr << "ist schon lange fertig !!!! \n";
}

void arbeiterverstorben(vorst_feldelement &f,void *vp)
{
   cerr << "Arbeiter " << f.apid << " muss irgendwie verstorben sein ... " << endl;
}

int bearbeite_auftrag(vorst_feldelement &f)
{
  static char puffer[64];
  int r;

  f.stat=S_Netz;
  cerr << "Arbeite mit " << f.aufnr 
       << ", schwitz schwitz ..." 
       << endl;
  r=read(0,puffer,64);
  puffer[r]='\0';
  if(strncmp(puffer,"fehler",6)==0) return -1;
  f.stat=S_lokalarbeit;

  return 0;
}

#include"mlsverw.h"

void handler_TERM(int s)
{
  cerr << "Ich sterbe ... " << endl;
  exit(1);
}

void install_termhandler(int s)
{
  struct sigaction siga;

  siga.sa_handler = handler_TERM;
  sigemptyset(&(siga.sa_mask));
  siga.sa_flags = 0;
  sigaction(s,&siga,NULL);
}

MLSverw<vorst_feldelement> mls(ftok(RADUSERSDBPATH,'R',getpagesize(),QUEUE_SIZE,MAX_W);

int debugflags=7;
main(int argc,char **argv)
{
  logmsginit(LOGMSG_STDERR,"radiusvor",0,0);
  install_termhandler(SIGTERM);
  install_termhandler(SIGINT);

  if(argc > 1 && argv[1][0]=='m')
    mls.meister(NULL);
  else if(argc > 1 && argv[1][0]=='d')
    mls.dump();
  else
    mls.arbeiter();
}

void check_procmask()
{
  int ret;
  sigset_t oldmask,newmask;
  sigemptyset(&newmask);
  sigprocmask(SIG_BLOCK,&newmask,&oldmask);

  if((ret=sigismember(&oldmask,SIGUSR1))<0)
  {
    cerr << "sigismember fehlgeschlagen " << endl;
    return;
  }
  cerr << "SIGUSR1 " << ( sigismember(&oldmask,SIGUSR1) ? "ist" : "ist nicht")
       << "blockiert" << endl;
}







