/*******************************************************************
 * semver.h Semaphor verwaltung                                    *
 * Verwaltet Semaphorary so, das verschienede Komponenten          *
 * verschiedene Koordinatiosnprobleme lsen knnen                 *
 *******************************************************************/
#ifndef SEMVER_H
#define SEMVER_H
#include<unistd.h>
#include<sys/errno.h>
#include<sys/types.h>
#include<sys/ipc.h>
#include<sys/sem.h>

class SemBM
{
  int semid;
  key_t semkey;
  int anzsem;
  int anleger;

  int nfrei;
public:
  SemBM(int panzsem,key_t psemkey);
  ~SemBM();
  int id() { return semid; }
  int anz() { return anzsem; }
  int alloc(int n);
  int soll_vorbelegung() { return anleger; } // 1: Initalisiere Semaphor
  void clear_anleger() { anleger=0; }        // nach fork im Sohn
};

class Leserschreiber2
{
  int semid;
  int semnum;
  int maxleser;
public:
  Leserschreiber2(SemBM& s,int pmaxleser);
  int semnum_leser() { return semnum; }
  int semnum_schreiber() { return semnum+1; }
  void lesesem();
  void lese_beg();
  void lese_end();
  void schr_beg();
  void schr_end();
};

class SemSig
{
  int semid;
  int semnum;
public:
  SemSig(SemBM& s);
  void erzeuge();
  void verbrauche();
  int lesesem();
};
#endif









