/*************************************************************************
 * Klasse...: Userrecvverw                                               *
 * Zweck....: Verwaltet Radius-Userdateieintrag                          *
 *            Die Userdateieintrge werden im hnlichen Format wie die   *
 *            Nachrichtenpakete gespeichert.                             *
 *************************************************************************/  
#include<assert.h>
#include"userrecord.h"

int Userrecverw::update(Userrecverw &upd,Userrecverw &alt)
{
#ifdef DEBUG
  extern int debugflags;
  if(debugflags & 4) cout << "Userrecverv::update" << endl;
#endif
  auth_attr *u;
  clear();
  // ersetze alle Check-Attribute, die in alt dabei sind
  for(auth_attr *a=alt.firstcheck();a!=NULL;a=alt.nextcheck())
  {
    if((u=upd.finde(a->id))!=NULL)
    {
#ifdef DEBUG
      if(debugflags&4) {cout << "\tersetze";u->print(cout);cout << endl;}
#endif
      add(u,ATTR_CHECK);
    }
    else
    {
      add(a,ATTR_CHECK);
    }
  }
  // Fge die Attribute aus upd hinzu, die noch nicht in alt sind
  for(auth_attr *up=upd.firstcheck();up!=NULL;up=upd.nextcheck())
  {
    if(alt.finde(up->id)==NULL)
    {
#ifdef DEBUG
      if(debugflags&4) {cout << "\tergnze";up->print(cout);cout << endl;}
#endif
      add(up,ATTR_CHECK);
    }
  }
    
  // Ersetze alle Reply-Attribute, die bei alt dabei sind
  for(auth_attr *a=alt.firstreply();a!=NULL;a=alt.nextreply())
  {
    if((u=upd.finde(a->id))!=NULL)
    {
#ifdef DEBUG
      if(debugflags&4) {cout << "\tersetze";u->print(cout);cout << endl;}
#endif
      add(u,ATTR_REPLY);
    }
    else
    {
      add(a,ATTR_REPLY);
    }
  }
  // Fge die Reply-Attribute aus upd hinzu, die noch nicht in alt sind
  for(auth_attr *up=upd.firstreply();up!=NULL;up=upd.nextreply())
  {
    if(alt.finde(up->id)==NULL)
    {
#ifdef DEBUG
      if(debugflags&4) {cout << "\tergnze";up->print(cout);cout << endl;}
#endif
      add(up,ATTR_REPLY);
    }
  }
}

int Userrecverw::add(auth_attr *a,int cor)
{
  if(a ==NULL) return 0; // arbeitet mit finde gutzusammen !
  memcpy(eptr,(char *)a,a->len);
  eptr += a->len;
  if(cor)
  {
    status = uv_addreply;
    ur->lenreply += a->len;
  }
  else
  {
    assert(status == uv_addcheck);
    ur->lencheck += a->len;
  }
  return 0;
}

int Userrecverw::add(Attreintrag *attr,char *value,int cor)
{
    int ret;
    
    auth_attr *merk = (auth_attr *)eptr;
    if((ret = addattrtolist(eptr,attr,value))>0)
    {
	if(cor)
	{
	    status = uv_addreply;
	    ur->lenreply += merk->len;
	}
	else
	{
	    assert(status == uv_addcheck);
	    ur->lencheck += merk->len;
	}
        return 0;
    }
    else
	return ret;
}

int Userrecverw::add(u_char attribut,char *value,int len,int cor)
{
    int ret;
    
    auth_attr *merk = (auth_attr *)eptr;
    if((ret = addattributtolist(eptr,attribut,value,len))>0)
    {
	if(cor)
	{
	    status = uv_addreply;
	    ur->lenreply += merk->len;
	}
	else
	{
	    assert(status == uv_addcheck);
	    ur->lencheck += merk->len;
	}
	return 0;
    }
    else
	return ret;
}

int Userrecverw::add(u_char attribut,UINT4 w,int cor)
{
  UINT4 v = htonl(w);
  return add(attribut,(char *)&v,sizeof(UINT4),cor);
}

void Userrecverw::print(ostream &ostr)
{
    ostr << "Checklist:";
    for(auth_attr *akt = firstcheck();akt != NULL;akt=nextcheck())
    {
	ostr << '\t';
	akt->print(ostr);
	ostr << '\n';
    }
    ostr << "Replyliste:";
    for(auth_attr *akt = firstreply();akt != NULL;akt=nextreply())
    {
	ostr << '\t';
	akt->print(ostr);
	ostr << '\n';
    }
    ostr << endl;
}

void Userrecverw::print(char *username,ostream &ostr) // invers zu parser
{
  int c=0;
  ostr << username << " ";
  for(auth_attr *akt = firstcheck();akt != NULL;akt=nextcheck())
  {
    if(c) ostr << ',';
    akt->print(ostr);
    c++;
  }
  ostr << endl;
  for(auth_attr *akt = firstreply();akt != NULL;akt=nextreply())
  {
    ostr << '\t';
    akt->print(ostr);
    ostr << '\n';
  }
  ostr << endl;
}










