/*************************************************************************
 * Klasse...: Userrecvverw                                               *
 * Zweck....: Verwaltet Radius-Userdateieintrag                          *
 *            Die Userdateieintrge werden im hnlichen Format wie die   *
 *            Nachrichtenpakete gespeichert.                             *
 *************************************************************************/  
#ifndef USERDICT_H
#define USERDICT_H
#include"authattr.h"

struct Userrecord
{
   int lencheck;
   int lenreply;
   auth_attr data[1];  // Hier folgen die Attribute
};

const int ATTR_CHECK =0;
const int ATTR_REPLY =1;

class Userrecverw
{
  enum Status { uv_addcheck,uv_addreply} status;
  Userrecord *ur;
  u_char *eptr;
  u_char *ptr;
public:
  Userrecverw() { ur=NULL;eptr = NULL;ptr=NULL; }
  Userrecverw(char *buffer) { init(buffer); }
  void init(char *buffer) { ur = (Userrecord *)buffer; clear(); }
  void setbuffer(char *buffer)
               { ur = (Userrecord *)buffer;
                 ptr=(u_char *)(ur->data);
                 eptr=(u_char *)ur + totallen();
		 status = uv_addreply;
               }
  void clear() { ur->lencheck = ur->lenreply =0;ptr=eptr=(u_char *)(ur->data);
		 status = uv_addcheck;
	       }
  int update(Userrecverw &upd,Userrecverw &alt);  
  int totallen() { return 2*sizeof(int) + ur ->lencheck + ur->lenreply; }
  int lencheck() { return ur->lencheck; }
  int lenreply() { return ur->lenreply; }
        
  int add(Attreintrag *attr,char *value,int cor);//cor=0 checklist, cor=1 reply
  int add(u_char attribut,char *wert,int len,int cor);
  int add(u_char attribut,UINT4 w,int cor);
  int add(auth_attr *a,int cor);

  auth_attr *firstcheck() 
  {
      ptr = (u_char *)(ur->data);
      return (ur->lencheck > 0) ? (auth_attr *)ptr : (auth_attr *)NULL;
  }
  auth_attr *nextcheck()
  {
      u_char *ptr_end = (u_char *)(ur->data)+ur->lencheck;
      if(ptr < ptr_end)
      {
	  ptr += (int)(((auth_attr *)ptr)->len);
      }  
      return (ptr < ptr_end ? (auth_attr *)ptr : (auth_attr *)NULL);
  }
  
  auth_attr *firstreply() 
  {
      ptr = (u_char *)(ur->data)+ur->lencheck;
      return (ur->lenreply > 0 ) ? (auth_attr *)ptr : (auth_attr *)NULL;
  }
  auth_attr *nextreply()
  {
      u_char *ptr_end = (u_char *)(ur->data)+ur->lencheck+ur->lenreply;
      if(ptr < ptr_end)
      {
	  ptr += (int)(((auth_attr *)ptr)->len);
      }  
      return (ptr < ptr_end ? (auth_attr *)ptr : (auth_attr *)NULL);
  }
 
  auth_attr *finde(u_char attribut)
  {
    u_char *ptr_end = (u_char *)(ur->data)+ur->lencheck+ur->lenreply;
    if(ptr==NULL || ptr >= ptr_end) ptr=(u_char *)(ur->data);
    u_char *anf = ptr;
    int i=0;
    if(ptr_end == (u_char *)(ur->data)) return NULL;
    
    //Zyklisches durchsuchen aller Attribute
    while(((auth_attr *)ptr)->id != attribut && (ptr!=anf || i==0))
    {
      ptr += ((auth_attr *)ptr)->len;
      if(ptr >= ptr_end) ptr=(u_char *)(ur->data);
      i++;
    }
    return (((auth_attr *)ptr)->id == attribut ? (auth_attr *)ptr : (auth_attr *)NULL);
  }

  void print(ostream &ostr);
  void print(char *username,ostream &ostr); // invers zu parser
  const Userrecord *data() { return ur;  }
  void ntoh() { ur->lencheck = htonl(ur->lencheck);
                ur->lenreply = htonl(ur->lenreply);
              }
  void hton() { ur->lencheck = ntohl(ur->lencheck);
                ur->lenreply = ntohl(ur->lenreply);
              }
};

#endif












