/**************************************************************************
 * Modul....: authattr.cc                                                 *
 * Zweck....: Implementiert Hilfsfunktionen fr Radisusattribute       *
 *------------------------------------------------------------------------*
 * copyright: 1996 Rudolf Weber W-4 Nonnenbroich und Weber Gbr            *
 *                 Ravensburg,Germany                                     *
 * email: rw@w-4.de                                                       *
 * Rights: see GNU-Copyleft (Distribution only with Source-Code)          *
 * Comericial Users are ask to send money                                 *
 **************************************************************************/
#include<assert.h>
#include<ctype.h>
#include<stdlib.h>
#include"conf.h"
#include"authattr.h"
#include"dict.h"
#include"ipaddrtools.h"
#include"zeit.h"

extern Attrdict dict;
extern int debugflags;

void auth_attr::print(ostream &str)
{
    Attreintrag *attr = dict[id];
    if(attr == NULL)
    {
	str << "Unbekannt " << (int)id << " Lnge " << (int)len << " ->";
        for(const u_char *p=data;p<data+len-2;p++) str << *p;
        cout << "<-";
	
    } 
    else
    {
        str << attr->name << " = ";attr->print(str,data,len);
    }
}

int addattrtolist(u_char *&ptr,Attreintrag *attr,char *value)
{
    
    assert(attr !=NULL);
    auth_attr *a = (auth_attr *)ptr;
    a->id = attr->id;
     
    switch(attr->type)
    {
    case PW_TYPE_STRING:
	{
	    int l=0;

	    ptr = a->data;
	    for(u_char *p = (u_char *)value;*p!='\0';*ptr++ = *p++) l++;
	    a->len = l+2;
	    return a->len;
	}
    case PW_TYPE_INTEGER:
	{
            int nd = 0;
	    UINT4 w;
	    
	    for(char *p=value;*p!='\0';p++)
	    {
		if(!isdigit(*p))
		{
		    nd = 1;
		    break;
		}
	    }
            if(nd)
	    {
		w = (UINT4)(attr->wert(value));
		
		if(w == (UINT4)(-1))
		{
                  cerr << "Unbekannter Wert " << value << " bei "
		      << attr->name << endl;
                  ptr = (u_char *)a;
		  return -1;
	      }
	    }
	    else
	    {
		w = atol(value);
	    }
	    *((UINT4 *)(a->data)) = htonl(w);
	    a->len = 2+sizeof(UINT4);
            ptr += a->len;
	    return a->len;
	}
    case PW_TYPE_IPADDR:
	{
    	   if(parseipaddr(*((struct in_addr *)(a->data)),value)<0)
           {
	       cerr << value << " ist keine gltige IP-Adresse \n";
               return -1;
	   } 
           a->len = 2+sizeof(struct in_addr);
	   ptr += a->len;
	   return a->len;
       }
    case PW_TYPE_DATE:
       {
	 int tag,monat,jahr;
	 if(sscanf(value,"%d.%d.%d",&tag,&monat,&jahr)==3)
	 {
	   UINT4 z;
	   Datum dat(tag,monat,jahr);
	   if(debugflags&4){cout << "Timeout-Datum ";dat.print(cout);cout<<endl;}
	   z = (UINT4)sekzeit696(dat);
	   if(z != (UINT4)(-1))
	   {
	     *((UINT4 *)(a->data)) = htonl(z);
	     a->len = 2+sizeof(UINT4);
	     ptr += a->len;
	     return a->len;
	   }
	 }
	 ptr = (u_char *)a;
	 return -1;
       }
    default:
	cerr << "auth_attr: Unbekannter Typ \n";
	return -1;
    }
    
}










