/**************************************************************************
 * Headerfile..: authattr.h                                               *
 * Zweck.......: Definiert Klasse auth_addr, die ein Radiusattribut       *
 *               darstellt                                                *
 *------------------------------------------------------------------------*
 * copyright: 1996 Rudolf Weber W-4 Nonnenbroich und Weber Gbr            *
 *                 Ravensburg,Germany                                     *
 * email: rw@w-4.de                                                       *
 * Rights: see GNU-Copyleft (Distribution only with Source-Code)          *
 * Comericial Users are ask to send money                                 *
 **************************************************************************/
#ifndef AUTHATTR_H
#define AUTHATTR_H
#include<sys/types.h>
#include<netinet/in.h>
#include<iostream.h>
#include"conf.h"
#include"dict.h"
#include"radiusproto.h"

struct auth_attr
{
  u_char id;
  u_char len;
  u_char data[1];

  void print(ostream &str);
};

/* Fgt Attributelement an Attributliste an.
   Annahme: Gengend Speicher vorhanden :-)
   Patameter: ptr : Einfgezeiger, zeigt vorher und nachher auf das Ende
                    der Liste
              attr: Zeiger auf Attributeintrag
              value: '\0' terminerter Sting mit Inhalt
   liefert: 0 falls ok
            -1 falls Fehler
*/
int addattrtolist(u_char *&ptr,Attreintrag *attr,char *value);

inline int addattributtolist(u_char *&ptr,u_char attribut,const char *wert,size_t len)
{
    auth_attr *a = (auth_attr *)ptr;
    a->id = attribut;
    memcpy((char *)(a->data),wert,len);
    a->len = len+2;
    ptr +=a->len;
    return a->len;
}

inline void getstring(char *s,auth_attr *a)
{
  memcpy(s,a->data,a->len-2);
  *(s+(a->len-2))='\0';
}

inline UINT4 getintval(auth_attr *a)
{
  return ntohl(*((UINT4 *)(a->data)));
}

/* fr Mehr-Mandatenradiusd
   user und realm sind zeiger auf einen gengend groen Speicherplatz
 */
inline void getuserandrealm(char *user,char *realm,auth_attr *a)
{
  u_char *p;
  char *pz;
  u_char *ende=a->data + a->len - 2;
  pz=user;
  p=a->data;
  while(p<ende && *p!='@') { *pz++ = *p++; }
  *pz='\0';
  if(p>=ende) 
  {
    *realm='\0';
  }
  else
  {
    p++;
    pz=realm;
    while(p<ende) { *pz++ = *p++; }
    *pz='\0';
  }
  
}
#endif









