/************************************************************************
 * Modul...: dict.cc                                                    *
 * Zweck...: Implementiert Klasse Attrdict                              *
 * Noch falsch: - Unbekannte Attribute konnen Programm crashen 
 *              - Falls Werte des letzten Attributs am anfang in datei
 *                stehen
 ************************************************************************/
#include<stdio.h>
#include<stdlib.h>
#include<string.h>
#include<sys/types.h>
#include<pwd.h>
#include<ctype.h>
#include<sys/time.h>	/* gettimeofday() */
#include<iostream.h>
#include<iomanip.h>
#include"conf.h"
#include"radiusproto.h"
#include"errmsg.h"
#include"dict.h"
#include"ipaddrtools.h"

extern char		*progname;
extern int		debugflags_flag;
extern char		*radius_dir;


/*************************************************************************
 *
 *	Function: dict_init
 *
 *	Purpose: Initialize the dictionary.  Read all ATTRIBUTES into
 *		 the dictionary_attributes list.  Read all VALUES into
 *		 the dictionary_values list.
 *
 *************************************************************************/

const char *Attrdict::init(char *datname)
{
    FILE	*dictfd;
    char	dummystr[64];
    char	namestr[64];
    char	valstr[64];
    char	attrstr[64];
    char	typestr[64];
    int	line_no;
    char	buffer[256];
    int	value;
    int	type;
    Attreintrag *attr;
    AttrValueeintrag **lv;
    
    
    int alind=0; // allokationsindex 
  
    if((dictfd = fopen(datname, "r")) == (FILE *)NULL)
    {
	fprintf (stderr, "%s: Couldn't open dictionary: %s\n",
		 progname, datname);
	return DICTFILE_READ_ERR;
    }

    line_no = 0;
    while(fgets(buffer, sizeof(buffer), dictfd) != (char *)NULL)
    {
	line_no++;
	
	/* Skip empty space */
	if(*buffer == '#' || *buffer == '\0' || *buffer == '\n') continue;

	if(strncmp(buffer, "ATTRIBUTE", 9) == 0)
	{
	    /* Read the ATTRIBUTE line */
	    if(sscanf(buffer,"%s%s%s%s",dummystr,namestr,valstr, typestr) != 4)
	    {
		fprintf(stderr,"%s: Invalid attribute on line %d of %s\n",
			progname,line_no,datname);
		return DICTFILE_ATTRLINE_ERR;
	    }

	    /*
	     * Validate all entries
	     */
	    if(strlen(namestr) > (size_t)31)
	    {
		fprintf(stderr,"%s: Invalid name length on line %d of %s\n",
			progname, line_no,datname);
		return DICTFILE_ATTRNAME_ERR;
	    }

	    if(!isdigit(*valstr)) 
	    {
		fprintf(stderr,"%s: Invalid value on line %d of %s\n",
			progname, line_no,datname);
		return DICTFILE_ATTRVALUE_ERR;
	    }
	    value = atoi(valstr);

	    if(strcmp(typestr, "string") == 0)
	    {
		type = PW_TYPE_STRING;
	    }
	    else if(strcmp(typestr, "integer") == 0)
	    {
		type = PW_TYPE_INTEGER;
	    }
	    else if(strcmp(typestr, "ipaddr") == 0)
	    {
		type = PW_TYPE_IPADDR;
	    }
	    else if(strcmp(typestr, "date") == 0)
	    {
		type = PW_TYPE_DATE;
	    }
            else if(strcmp(typestr, "abinary") == 0)
	    {
		type = PW_TYPE_FILTER_BINARY;
	    }
	    else
	    {
		fprintf(stderr,"%s: Invalid type on line %d of %s\n",
			progname, line_no,datname);
		return DICTFILE_ATTRTYPE_ERR;
	    }

	    /* Create a new attribute for the list */
	    if(value < Attrdictfirsterw)
	    {
	      if(value >= Attrdictanzstd)
	      {
		fprintf(stderr,"%s: Change Parameter Attrdictanzstd in dict.h to %d\n",progname,value);
		exit(1);
	      }
	      attr = std + value;
	    }
	    else
	    {
	      int offset = value - Attrdictfirsterw;
	      if(offset >= Attrdictanzerw)
	      {
		fprintf(stderr,"%s: Change Parameter Attrdictanzerw in dict.h to %d\n",progname,offset);
		exit(1);
	      }
	      attr = erw + offset;
	    }
	    attr->init((Attribut_t)value,namestr,type);
            map[attr->name]=attr;        // in Tabelle eintragen
	    
	}
	else if(strncmp(buffer, "VALUE", 5) == 0)
	{	    /* Read the VALUE line */
	    if(sscanf(buffer, "%s%s%s%s", dummystr, attrstr,
		      namestr, valstr) != 4)
	    {
		fprintf(stderr,"%s: Invalid value entry on line %d of %s\n",
			progname, line_no,datname);
		return DICTFILE_VALLINE_ERR;
	    }

	    /*
	     * Validate all entries
	     */
	    if(strlen(attrstr) > (size_t)31)
	    {
	      fprintf(stderr,"%s: Invalid attribute length on line %d of %s\n",
		      progname, line_no,datname);
	      return DICTFILE_VALATTR_ERR;
	    }

	    if(strlen(namestr) > (size_t)31)
	    {
		fprintf(stderr,"%s: Invalid name length on line %d of %s\n",
			progname, line_no,datname);
		return DICTFILE_VALNAME_ERR;
	    }

	    if(!isdigit(*valstr))
	    {
		fprintf(stderr,"%s: Invalid value on line %d of %s\n",
			progname, line_no,datname);
		return DICTFILE_VALVALUE_ERR;
	    }
	    value = atoi(valstr);
	
            if(attr == NULL || strcmp(attr->name,attrstr)!=0)
            {
		if(! map.contains(attrstr))
		{
                  fprintf(stderr,"%s: Value of unknown attribut on line %d of %s",
			  progname,line_no,datname);
		  return UNKOWN_ATTR;  
		}
                attr = (*this)[attrstr];
                lv = &(attr->values);
						
            }    
	    /* Create a new VALUE entry for the list */
            *lv = new AttrValueeintrag(namestr,attr,value);
	    if(*lv == NULL)
	    {
		fprintf(stderr, "%s: out of memory\n",progname);
		return MEMORY_ERR;
	    }
	    /* Insert it into the list */
	    lv = &((*lv)->nxt);
	}
    }
    fclose(dictfd);
    return NULL;
}

Attreintrag *Attrdict::operator[](Attribut_t a)
{
    Attreintrag *ret = (a < Attrdictfirsterw ? &(std[(int)a])
			: &(erw[(int)a - Attrdictfirsterw]));
    return (ret->name[0]!='\0' ? ret : (Attreintrag *)NULL);
   // unbekanntes Attribut ?????    
}

const char *Attreintrag::operator()(int val)
{
   AttrValueeintrag *akt = values;
   while(akt!= NULL && akt->value != val)
   {
     akt = akt->nxt;
   }
   return ((akt!=NULL && akt->value == val) ? akt->name : (char *)0);
}

int Attreintrag::wert(char *attrbez)
{
  AttrValueeintrag *akt = values;
  while(akt!= NULL && strcmp(akt->name,attrbez) != 0) akt = akt->nxt;
  return ((akt!=NULL && strcmp(akt->name,attrbez)==0 ) ? akt->value : -1);
}

void Attreintrag::print(ostream &ostr,u_char *data,int len,int log)
{
   switch(type)
   {
   case PW_TYPE_STRING:
       if(!log) ostr << '"';
       for(const u_char *p=data;p<data+len-2 && *p!='\0';p++)
       {
	 if(isprint(*p))
	 {
	   ostr << *p;
	 }
	 else
	 {
	   ostr << '\\' << oct << (int)*p << dec ;
	 }
       }
       if(!log) ostr << '"';
       break;
   case PW_TYPE_INTEGER:
       {
	   UINT4 val = ntohl(*((UINT4 *)data));
	   const char *ret = (*this)(val);
	   if(ret == (char *)0) ostr << val;
	   else ostr << ret;
       }
       break;
   case PW_TYPE_IPADDR:
       {
	   char s[16];
	   ostr << iptostr(s,*((struct in_addr *)data));
       }
       break;
   case PW_TYPE_DATE:
       {
	   char zstr[15];
           long tv = ntohl(*((UINT4 *)data));
	   strftime(zstr,11,"%d.%m.%Y",localtime(&tv));
	   ostr << zstr;
       }
       break;
   default:
       ostr << "unbekannter Typ " << (int)type << " ";
       for(const u_char *p=data;p<data+len-2;p++)
       {
	 if(isprint(*p))
	 {
	   ostr << *p;
	 }
	 else
	 {
	   ostr << '\\' << oct << (int)*p << dec ;
	 }
       }
   }
}

void Attreintrag::string(char *aname,char *vstr,u_char *data,int len,int log=0)
{
   char *pz=vstr;
   strcpy(aname,name);
   switch(type)
   {
   case PW_TYPE_STRING:
       if(!log) *pz++ = '"';
       for(const u_char *p=data;p<data+len-2;p++)
       {
	   *pz++= *p;
       }
       if(!log) *pz++ = '"';
       *pz='\0';
       break;
   case PW_TYPE_INTEGER:
       {
	   UINT4 val = ntohl(*((UINT4 *)data));
	   const char *ret = (*this)(val);
	   if(ret == (char *)0) sprintf(vstr,"%d",val);
	   else strcpy(vstr,ret);
       }
       break;
   case PW_TYPE_IPADDR:
       {
	 iptostr(vstr,*((struct in_addr *)data));
       }
       break;
   case PW_TYPE_DATE:
       {
	 long tv = ntohl(*((UINT4 *)data));
	 strftime(vstr,11,"%d.%m.%Y",localtime(&tv));
       }
       break;
   default:
     for(const u_char *p=data;p<data+len-2;p++) *pz++ << *p;
     *pz='\0';
   }
}

#ifdef TEST_DICT
#include<getopt.h>
#include"config.h"
#include"etext.h"

Attrdict dict;
char *progname;

void test(char *testattr)
{
    Attreintrag *attr,*attr2;
   
    attr = dict[testattr];
    if(attr != NULL)
    {
	attr2 = dict[attr->id];
        if(attr2 != NULL)
        {
	    printf("Attribut %d ist %s\n",attr->id,attr2->name);
	}
    }
}

void bearbdat(Attreintrag *attr,FILE *fp)
{
    char value[80];
    char *bisp;
    int wert;

    while(fgets(value,80,fp)!=NULL)
    {
	wert = (int)strtol(value,&bisp,10);
	if(bisp > value)
	{
	    attr->print(cout,wert);
	    cout << endl;
	}
	else
	{
	    chop(value);
	    int ret = attr->wert(value);
	    if(ret > 0)
		cout << ret << endl;
	    else
		cerr << "Unbekannt: " << value << endl;
	}
    }
}

int main(int argc,char **argv)
{
    const char *ret;
    char *raddict = RADDICT;
    Attreintrag *attr,*attr2;    
    struct option long_options[] =
    {   {"dict",1,0,1 },
        {0,0,0,0}
    };
    int oi = 0;
    int c;
    progname = argv[0];

    while((c=getopt_long(argc,argv,"",long_options,&oi))!=-1)
    {
	switch(c)
	{
	case 1:
	    raddict = optarg;
	    break;
	default:
	    cerr << "Unbekannte Option " << c << endl;
	}
    } 

    ret = dict.init(raddict);
    if(ret!=NULL) 
    {
	cerr << ret << endl;
	exit(1);
    }
    if(argc-optind == 0)
    {
	fprintf(stderr,"Syntax Ok\n");
    }
    else if(argc-optind == 1)
    {
	test(argv[optind]);
    }
    else if(argc-optind > 1)
    {
	name_t name = argv[optind];
	Attreintrag *attr = dict[name];
	if(attr != NULL)
	{
	    if(argv[optind+1][0]!='-')
	    {
		char *value = argv[optind+1];
		char *bisp;
		int wert = (int)strtol(value,&bisp,10);
		if(bisp > value)
		{
		    attr->print(cout,wert);
		    cout << endl;
		}
		else
		{
		    int ret = attr->wert(value);
		    if(ret > 0)
			cout << ret << endl;
		    else
			cerr << "Unbekannt: " << value << endl;
		}
	    }
	    else
	    {
		bearbdat(attr,stdin);
	    }

	}
	else
	{
	    cerr << "Attribut " << name << " unbekannt\n";
	}
    }
}
#endif



