/**************************************
 * Rudolfs Ip-Adsstools               *
 **************************************/
#ifndef IPADDRTOOLS_H
#define IPADDRTOOLS_H

#include<stdio.h>
#include<netinet/in.h>
#include<netdb.h>

inline int parseipaddr(struct in_addr& erg,const char *str)
{
  unsigned long b0,b2,b1,b3;

  if(sscanf(str,"%lu.%lu.%lu.%lu",&b3,&b2,&b1,&b0)!=4) return -1;
  if((b3&~255) || (b2&~255) || (b1&~255) || (b0&~255)) return -1; 
  erg.s_addr = htonl((b3 << 24)|(b2<<16)|(b1<<8)|b0);
  return 0;
}

inline char *iptostr(char s[16],const struct in_addr ipaddr)
{
  sprintf(s,"%lu.%lu.%lu.%lu",
	  (ipaddr.s_addr & 255),
	  (ipaddr.s_addr & (255<<8))>>8,
	  (ipaddr.s_addr & (255<<16))>>16,
	  ipaddr.s_addr >> 24);
   return s;
}

// Ascend-Netmask-Schreibweise /a zu netzmaske ind hostorder
inline UINT4 netmaskascend2unix_ho(short a)
{
  return(~((1<<(32-a))-1) & ~0);
}

inline ostream& operator<<(ostream& str,struct sockaddr_in &sa)
{
    char iptext[16];
    // str << '(' << sa.sin_family << ')';
    str << iptostr(iptext,sa.sin_addr)
	<< ':' << ntohs(sa.sin_port);
    
    return str;
}

inline char *ip2hostname(UINT4 h_ipaddr)
{
  struct hostent  *hp;
  UINT4           n_ipaddr = htonl (h_ipaddr);
  
  hp = gethostbyaddr ((char *) &n_ipaddr, sizeof (struct in_addr),
			   AF_INET);
  return ((hp==NULL)?"unknown":hp->h_name);
} 

#endif

