/**************************************************************************
 * Headerfile...: nachricht.h                                             *
 * copyright: 1996 Rudolf Weber W-4 Nonnenbroich und Weber Gbr            *
 *                 Ravensburg,Germany                                     *
 * copyright: 1997 Rudolf weber Informatik-Beratung Ravensburg            *
 * email: rw@w-4.de                                                       *
 * Rights: see GNU-Copyleft (Distribution only with Source-Code)          *
 * Comericial Users are ask to send money                                 *
 **************************************************************************/
#ifndef RBRD_H
#define RBRD_H
#include"conf.h"
#include"radiusproto.h"
#include"dict.h"
#include"secinf.h"
#include<assert.h> 
#include<sys/types.h>
#include<sys/socket.h>
#include<netinet/in.h>
#include"authattr.h"


class Nachricht
{
protected:

  auth_hdr *auth;
  int bufflen;

  u_char *ptr;           // fr Attributiterator
  u_char *ptr_end;       // ende fr Attributiterator

  u_char digest[AUTH_VECTOR_LEN];
  u_char secret[256];

  void c_init();

public: 
  Nachricht(char *buffer,int bl) 
    { 
      auth = (auth_hdr *)buffer;bufflen=bl;
      c_init();
    }

  int id()                  { return (int)(auth->id);}
  u_char code()             { return auth->code; }
  int totallen()            { return ntohs(auth->length); }

  const u_char *getdigest() { return digest; }
  const u_char *getvector() { return auth->vector; }
  const u_char *getsecret() { return secret; }
  int nettolen()            { return totallen()-sizeof(auth_hdr)+2;} 

  auth_attr *first() { return (ptr_end > auth->data ? (auth_attr *)(ptr=auth->data) : (auth_attr *)NULL); }
  auth_attr *next()  { if(ptr < ptr_end)
                       {
                         ptr += (int)(((auth_attr *)ptr)->len);
                       }  
                       return (ptr < ptr_end && 
			       (int)(((auth_attr *)ptr)->len) > 0  ?
			       (auth_attr *)ptr : (auth_attr *)NULL);
		     }
  auth_attr *finde(u_char attribut);
  void print(ostream &ostr);
  
  int calc_digest(const u_char *secret); 
};

class Empfangen : public Nachricht
{
protected:
  struct sockaddr_in *absender;
  int abssecret(const char *realm,Secinf *si);//holt secret aus Clientdatenbank
public:
  Empfangen(struct sockaddr_in &ab,char *buffer,int bl):Nachricht(buffer,bl)
    { absender = &ab; }
  const struct sockaddr_in& getabsender() { return *absender; }
  int recv(int sockfd);     // empfngt eine Nachricht
  int init(struct sockaddr_in &ab,u_char *buffer,int length);
  int check_reply(const u_char altvector[],const u_char *secret); // ==0 ok <0 not ok
  void print(ostream &ostr);
  void setsecret(const u_char *psecret) 
    { strcpy((char *)secret,(const char *)psecret); }
  int bestimme_digest(Secinf *si,const char *realm="");     
  int authenticate(Secinf *si,const char *realm="");    // check_reply mit 000...00-Vektor  
};

class Zusenden : public Nachricht
{
public:
  Zusenden(char *buffer,int bl):Nachricht(buffer,bl) {}
  int initsend(u_char code,u_char id,const u_char *vector);
  void setvector(const u_char *vector);
  void setid(long snr) { auth->id = (u_char)(snr & ~(u_char)0);}
  void addattr(u_char attribut,const char *wert,size_t len)
    {
      u_short l = ntohs(auth->length)+
	addattributtolist(ptr_end,attribut,wert,len);
      auth->length=htons(l);
    }
  void addattr(u_char attribut,UINT4 val)
    {
      UINT4 vc = htonl(val);
      addattr(attribut,(char *)(&vc),sizeof(UINT4));
    }
  void addattr(Attreintrag *attr,char *value)
    {
      u_short l = ntohs(auth->length)+
	addattrtolist(ptr_end,attr,value);
      auth->length=htons(l);
    }
  int copyreplyattr(auth_attr *ra,int lang);
  int calc_responsedigest(const u_char *rsecret);
  
  int emplength() { return(ptr_end - (u_char *)auth); }
  int send(int sockfd,const struct sockaddr_in& saremote);
  
};

inline int min(int a,int b) { return (a < b ? a : b); }

int ciffrepassword(u_char *clearpass,u_char *encryptpass,int len,const u_char *digest);
// Generates a random vector of AUTH_VECTOR_LEN octets.
// Returns:	the vector (call by reference)
void random_vector(u_char *vector);

inline void printvectorhex(ostream& ostr,u_char *vector,int len)
{
  u_char a;
    
  for(u_char *b=vector;b<vector+len;b++)
  {
    a = (*b >> 4);
    ostr << (char)(a<10 ? a+'0' : a-10+'a');
    a = (*b & 0xf);
    ostr << (char)(a<10 ? a+'0' : a-10+'a');
  }
}

const char *msgtype2str(u_char code);
const u_char str2msgtype(const char *str);
void listmsgtypes(ostream &ostr);

#endif
