// This may look like C code, but it is really -*- C++ -*-
/* 
Copyright (C) 1988 Free Software Foundation
    written by Doug Lea (dl@rocky.oswego.edu)

This file is part of the GNU C++ Library.  This library is free
software; you can redistribute it and/or modify it under the terms of
the GNU Library General Public License as published by the Free
Software Foundation; either version 2 of the License, or (at your
option) any later version.  This library is distributed in the hope
that it will be useful, but WITHOUT ANY WARRANTY; without even the
implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
PURPOSE.  See the GNU Library General Public License for more details.
You should have received a copy of the GNU Library General Public
License along with this library; if not, write to the Free Software
Foundation, 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
*/


#ifndef _name_tAttreintragptrAVLMap_h
#ifdef __GNUG__
#pragma interface
#endif
#define _name_tAttreintragptrAVLMap_h 1

#include "name_t.Attreintragptr.Map.h"

struct name_tAttreintragptrAVLNode
{
  name_tAttreintragptrAVLNode*      lt;
  name_tAttreintragptrAVLNode*      rt;
  name_t                 item;
  Attreintragptr                 cont;
  char                stat;
                      name_tAttreintragptrAVLNode(name_t  h, Attreintragptr  c, 
                                    name_tAttreintragptrAVLNode* l=0, name_tAttreintragptrAVLNode* r=0);
                      ~name_tAttreintragptrAVLNode();
};

inline name_tAttreintragptrAVLNode::name_tAttreintragptrAVLNode(name_t  h, Attreintragptr  c, 
                                    name_tAttreintragptrAVLNode* l, name_tAttreintragptrAVLNode* r)
     :lt(l), rt(r), item(h), cont(c), stat(0) {}

inline name_tAttreintragptrAVLNode::~name_tAttreintragptrAVLNode() {}

typedef name_tAttreintragptrAVLNode* name_tAttreintragptrAVLNodePtr;


class name_tAttreintragptrAVLMap : public name_tAttreintragptrMap
{
protected:
  name_tAttreintragptrAVLNode*   root;

  name_tAttreintragptrAVLNode*   leftmost();
  name_tAttreintragptrAVLNode*   rightmost();
  name_tAttreintragptrAVLNode*   pred(name_tAttreintragptrAVLNode* t);
  name_tAttreintragptrAVLNode*   succ(name_tAttreintragptrAVLNode* t);
  void            _kill(name_tAttreintragptrAVLNode* t);
  void            _add(name_tAttreintragptrAVLNode*& t);
  void            _del(name_tAttreintragptrAVLNode* p, name_tAttreintragptrAVLNode*& t);

public:
                name_tAttreintragptrAVLMap(Attreintragptr  dflt);
                name_tAttreintragptrAVLMap(name_tAttreintragptrAVLMap& a);
  inline               ~name_tAttreintragptrAVLMap();

  Attreintragptr&          operator [] (name_t  key);

  void          del(name_t  key);

  inline Pix           first();
  inline void          next(Pix& i);
  inline name_t&          key(Pix i);
  inline Attreintragptr&          contents(Pix i);

  Pix           seek(name_t  key);
  inline int           contains(name_t  key);

  inline void          clear(); 

  Pix           last();
  void          prev(Pix& i);

  int           OK();
};

inline name_tAttreintragptrAVLMap::~name_tAttreintragptrAVLMap()
{
  _kill(root);
}

inline name_tAttreintragptrAVLMap::name_tAttreintragptrAVLMap(Attreintragptr  dflt) :name_tAttreintragptrMap(dflt)
{
  root = 0;
}

inline Pix name_tAttreintragptrAVLMap::first()
{
  return Pix(leftmost());
}

inline Pix name_tAttreintragptrAVLMap::last()
{
  return Pix(rightmost());
}

inline void name_tAttreintragptrAVLMap::next(Pix& i)
{
  if (i != 0) i = Pix(succ((name_tAttreintragptrAVLNode*)i));
}

inline void name_tAttreintragptrAVLMap::prev(Pix& i)
{
  if (i != 0) i = Pix(pred((name_tAttreintragptrAVLNode*)i));
}

inline name_t& name_tAttreintragptrAVLMap::key(Pix i)
{
  if (i == 0) error("null Pix");
  return ((name_tAttreintragptrAVLNode*)i)->item;
}

inline Attreintragptr& name_tAttreintragptrAVLMap::contents(Pix i)
{
  if (i == 0) error("null Pix");
  return ((name_tAttreintragptrAVLNode*)i)->cont;
}

inline void name_tAttreintragptrAVLMap::clear()
{
  _kill(root);
  count = 0;
  root = 0;
}

inline int name_tAttreintragptrAVLMap::contains(name_t  key)
{
  return seek(key) != 0;
}

#endif
