// This may look like C code, but it is really -*- C++ -*-
/* 
Copyright (C) 1988 Free Software Foundation
    written by Doug Lea (dl@rocky.oswego.edu)

This file is part of the GNU C++ Library.  This library is free
software; you can redistribute it and/or modify it under the terms of
the GNU Library General Public License as published by the Free
Software Foundation; either version 2 of the License, or (at your
option) any later version.  This library is distributed in the hope
that it will be useful, but WITHOUT ANY WARRANTY; without even the
implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
PURPOSE.  See the GNU Library General Public License for more details.
You should have received a copy of the GNU Library General Public
License along with this library; if not, write to the Free Software
Foundation, 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
*/


#ifndef _name_tAttreintragptrMap_h
#ifdef __GNUG__
#pragma interface
#endif
#define _name_tAttreintragptrMap_h 1

#include <Pix.h>
#include "name_t.defs.h"

class name_tAttreintragptrMap
{
protected:
  int                   count;
  Attreintragptr                   def;

public:
                        name_tAttreintragptrMap(Attreintragptr  dflt);
  inline virtual              ~name_tAttreintragptrMap();

  int                   length() const; // current number of items
  int                   empty() const;

  virtual int           contains(name_t  key);      // is key mapped?

  virtual void          clear();                 // delete all items

  virtual Attreintragptr&          operator [] (name_t  key) = 0; // access contents by key

  virtual void          del(name_t  key) = 0;       // delete entry

  virtual Pix           first() = 0;             // Pix of first item or 0
  virtual void          next(Pix& i) = 0;        // advance to next or 0
  virtual name_t&          key(Pix i) = 0;          // access key at i
  virtual Attreintragptr&          contents(Pix i) = 0;     // access contents at i

  virtual int           owns(Pix i);             // is i a valid Pix  ?
  virtual Pix           seek(name_t  key);          // Pix of key

  Attreintragptr&                  dflt();                  // access default val

  void                  error(const char* msg);
  virtual int           OK() = 0;                // rep invariant
};


inline name_tAttreintragptrMap::~name_tAttreintragptrMap() {}

inline int name_tAttreintragptrMap::length() const
{
  return count;
}

inline int name_tAttreintragptrMap::empty() const
{
  return count == 0;
}

inline Attreintragptr& name_tAttreintragptrMap::dflt()
{
  return def;
}

inline name_tAttreintragptrMap::name_tAttreintragptrMap(Attreintragptr  dflt) :def(dflt)
{
  count = 0;
}

#endif
