/**************************************************************************
 * Modul....: radiusclient.cc                                             *
 * Zweck....: Implentiert Funkionen aus radiusclient.h                    *
 *------------------------------------------------------------------------*
 * copyright: 1996 Rudolf Weber W-4 Nonnenbroich und Weber Gbr            *
 *                 Ravensburg,Germany                                     *
 *            1997 Rudolf Weber Ravensburg Germany                        *
 * email: rw@weber.rv.infnet.verein.de                                    *
 * Rights: see GNU-Copyleft (Distribution only with Source-Code)          *
 * Comericial Users are ask to send money                                 *
 **************************************************************************/
#include<iostream.h>
#include<sys/time.h>
#include<sys/types.h>
#include<unistd.h>
#include"logmsg.h"
#include"radius.h"
#include"radiusclient.h"
#include"config.h"
#include<ctype.h>
#include<netdb.h>

extern int debugflags;
 
int opensocket(struct sockaddr_in& salocal)
{
   int salen = sizeof(salocal);
   int sockfd;
   int sockOptFlag = 1;
   int r;
            
   sockfd = socket(AF_INET,SOCK_DGRAM,0);
   if (sockfd < 0)
   {
       cerr << "socket" << strerror(errno) << endl;
       exit(-1);
   }
   sockOptFlag = 1;	/* enable */
   if ( setsockopt( sockfd, SOL_SOCKET, SO_REUSEADDR,
		   (char*) &sockOptFlag, sizeof(sockOptFlag)) < 0 )
   {
       cerr << "setsockopt auth SO_REUSEADDR" << strerror(errno) << endl;
       exit(-1);
   }
   
   memset ((char *) (&salocal), '\0', sizeof (salocal));
   salocal.sin_family = AF_INET;
   salocal.sin_addr.s_addr = INADDR_ANY;
   salocal.sin_port = 0;
   
   r = bind (sockfd,(struct sockaddr *)&salocal, sizeof(salocal));
   if (r < 0)
   {
       cerr << "auth bind :" << strerror(errno) << endl;
       exit(-1);
   }
   /*----- probeausgabe Adresse -------*/
   salen = sizeof(salocal);
   if(getsockname(sockfd,(struct sockaddr *)&salocal,&salen)<0)
   {
       cerr << "getsockname :" << strerror(errno) << endl;exit(1);
   }
#ifdef DEBUG   
   cerr << "Absenderadresse " << salocal << endl; 
#endif   
   return sockfd;
}

int genempfaddr(struct sockaddr_in &saremote,char *addrstr,char *dienst)
{
    u_short port;
    char *p;
    struct in_addr ipaddr;

     /*------- Ip-Adresse und Port aus Kommandozeile auswerten ----*/
    for(p=addrstr;*p!='\0' && *p!=':';p++);
    if(*p == '\0')
    {
	struct servent *svp = getservbyname(dienst, "udp");
	if (svp == (struct servent *) 0)
	{
	    cerr << " No such service: radius/udp\n";
	    exit(-1);
	}
	port = (u_short) svp->s_port;
    }
    else
    {
	if(*p != ':') 
	{
	    cerr << "Parameter: IPaddr:port\n";exit(-1);
	}
	*p='\0';
	port = htons(atoi(++p));
    }    
    if(parseipaddr(ipaddr,addrstr)<0)
    {
      // addrstr ist keine gltige IP-adresse
      struct hostent *hptr = gethostbyname(addrstr);
      if(hptr == NULL)
      {
	if(h_errno == HOST_NOT_FOUND)
	  cerr << "Rechner " << addrstr << " nicht gefunden !" << endl;
	else 
	  cerr << "Sonstiger Fehler beim auflsen von " << addrstr << endl;
	exit(1);
      }
      ipaddr=*(struct in_addr *)(hptr->h_addr_list[0]);
    }
#ifdef DEBUG
    char ipadrstring[16];
    cerr << "Sende an " << iptostr(ipadrstring,ipaddr) 
        << ':' << ntohs(port) << endl;
#endif    
    memset((char *) (&saremote), '\0', sizeof (saremote));
    saremote.sin_family = AF_INET;
    saremote.sin_addr.s_addr = ipaddr.s_addr;
    saremote.sin_port = port;
    
    return 0;
}

struct in_addr myaddr()
{
  char hostname[30];
  struct hostent *hptr;
  if(gethostname(hostname,30)<0)
  { cerr << "gethostname: " << strerror(errno) << endl; exit(1);
  }
#ifdef DEBUG
  cerr << hostname << endl;
#endif 
  hptr = gethostbyname(hostname);
  return *(struct in_addr *)(hptr->h_addr_list[0]);
}

inline int parsevaluepair(char *&name,char *&realm,char *&val,char *buf)
{
  char *p=buf;
  realm=(char *)0;val=(char *)0;
  int namelen,vallen;
  while(isspace(*p)) p++;
  name = p;
  /*----- Name lesen ----*/
  while(isalpha(*p) || *p=='_') p++;
  namelen = p-name;
  
  /*------ Realm lesen ---*/
  if(*p == '(')
  {
    realm = ++p;
    while(*p!='\0' && *p!=')') p++;
    if(*p!=')') return -1;
    *p++='\0';
  }
  /*----- Zwischenraum mit = ---- */
  while(isspace(*p)) p++;
  if(*p++ != '=') return -1;
  while(isspace(*p)) p++;

  /*---- Wert bis zeilenende oder # abzglich leerzeichen --- */
  val = p;
  while(*p!='\0' && *p!='\n' && *p!='#') p++;
  p--;
  while(isspace(*p)) p--;
  p++;
  *p = '\0';
  if(namelen==0) return -1;
  *(name+namelen) = '\0';
  return 0;
}

Clientconf::Clientconf()
{
  setdefaults();
}

Clientconf::Clientconf(char *cf)
{
  if(readconfig(cf)<0) exit(1);
}

void Clientconf::setdefaults()
{
  radhosts = NULL;
  radaccthosts= NULL;

  clientpath=RADCLIENTS;
  dictpath=RADDICT;
  dbhost = NULL;
  radius_timeout=DEFAULT_RADIUS_TIMEOUT;
  radius_retries=DEFAULT_RADIUS_RETRIES;
  maxlogintries = DEFAULT_MAXLOGINTRIES;
  logintimeout  = DEFAULT_LOGIN_TIMEOUT;
  authorder = AUTH_RADIUS_FST;
  nologin   = DEFAULT_NOLOGIN;
  issue     = DEFAULT_ISSUE;
  login_radius=DEFAULT_LOGIN_RADIUS;
  seqfile=DEFAULT_SEQFILE;
  mapfile=DEFAULT_MAPFILE;
  default_realm=DEFAULT_DEFAULT_REALM;
  start_ppp=DEFAULT_START_PPPD;
  login_local=DEFAULT_LOGIN_LOCAL;
  port_pool=DEFAULT_PORT_POOL;
  default_path=DEFAULT_ENV_PATH;
  ausdrucktmpl = NULL;
  ausdrucksc = NULL;
  tmpl=TEMPL;
}


char* defaultclientconfigfile()
{
  static char filename[128];

  char *radhome = getenv("RADHOME");
  if(radhome != NULL)  
    sprintf(filename,"%s/client.conf",radhome);
  else
    strcpy(filename,RADCLIENTCONF);

  return filename;
}


int  Clientconf::readconfig(char *filename)
{
  char puffer[128];int zeile;
  char *name,*value,*realm;
  Server **akt,**akta;   // Serverlisteniteratoren fuer radius und radacct

  FILE *fp=fopen(filename,"r");
  if(fp==NULL)
  {
    logmsg(LOG_ERR,"Client-Konfigurationsdatei %s nicht gefunden ",filename);
    return -1;
  }
  setdefaults();
  akt = &radhosts;
  akta = &radaccthosts;
  zeile=0;
  while(fgets(puffer,128,fp)!=NULL)
  {
    zeile++;
    if(puffer[0]=='#') continue;         // Kommentarzeichen
    if(parsevaluepair(name,realm,value,puffer)<0)
    {
      logmsg(LOG_ERR,"Ungltiges Paar in %s Zeile %d",filename,zeile);
      continue;
    }
    if(strcmp(name,"radhost")==0)
    {
      *akt=new Server(value);
      akt = &((*akt)->nxt);
    }
    else if(strcmp(name,"secret")==0)
    {
      if(realm==(char *)0) realm="";
      secinf.insert(realm,(u_char *)value);
    }
    else if(strcmp(name,"radaccthost")==0)
    {
      *akta=new Server(value,"radacct");
      akta = &((*akta)->nxt);
    }
    else if(strcmp(name,"clientpath")==0)
    {
      clientpath = strdup(value);
    }
    else if(strcmp(name,"dictpath")==0)
    {
      dictpath = strdup(value);
    }
    else if(strcmp(name,"tmpl")==0)
    {
      tmpl = strdup(value);
    }
    else if(strcmp(name,"auth_order")==0)
    {
      char *p=value;
      p=strtok(value, ", \t");
      if (!strncmp(p, "local", 5)) authorder = AUTH_LOCAL_FST;
      else if (!strncmp(p, "radius", 6)) authorder = AUTH_RADIUS_FST;
      else
      {
	logmsg(LOG_ERR,"Clientconf: auth_order: unknown keyword: %s in %s line %d",p,filename,zeile);
        continue;
      }
      p = strtok(NULL, ", \t");
      if(!p || *p=='\0') continue;
      if ((authorder & AUTH_RADIUS_FST) && !strcmp(p, "local"))
	authorder = authorder | AUTH_LOCAL_SND;
      else if ((authorder & AUTH_LOCAL_FST) && !strcmp(p, "radius"))
	authorder | AUTH_RADIUS_SND;   
      else
      {
	logmsg(LOG_ERR,"Clientconf: auth_order: unknown or unexpected keyword: %s in %s line %d",p,filename,zeile);
	continue;
      }
    }
    else if(strcmp(name,"login_tries")==0)
    {
      maxlogintries=atoi(value);
    }
    else if(strcmp(name,"login_timeout")==0)
    {
      logintimeout=atoi(value);
    }
    else if(strcmp(name,"nologin")==0)
    {
      nologin = strdup(value);
    }
    else if(strcmp(name,"issue")==0)
    {
      issue = strdup(value);
    }
    else if(strcmp(name,"start_ppp") == 0)
    {
      start_ppp = strdup(value);
    }
    else if (strcmp (name, "login_radius") == 0)
    {
      login_radius = strdup (value);
    }
    else if (strcmp (name, "seqfile") == 0)
    {
      seqfile = strdup (value);
    }
    else if (strcmp (name, "mapfile") == 0)
    {
      mapfile = strdup (value);
    }
    else if (strcmp (name, "default_realm") == 0)
    {
      default_realm = strdup (value);
    }
    else if (strcmp (name, "radius_timeout") == 0)
    {
      radius_timeout = atol(value);
    }
    else if (strcmp (name, "radius_retries") == 0)
    {
      radius_retries = atoi(value);
    }
    else if (strcmp (name, "login_local") == 0)
    {
      login_local = strdup (value);
    }
    else if (strcmp (name, "port_pool") == 0)
    {
      port_pool = strdup (value);
    }
    else if(strcmp(name,"default_path")==0)
    {
      default_path=strdup(value);
    }
    else if(strcmp(name,"dbhost")==0)
    {
      dbhost=strdup(value);
    }
    else if(strcmp(name,"ausdrucktmpl")==0)
    {
      ausdrucktmpl=strdup(value);
    }
    else if(strcmp(name,"ausdrucksc")==0)
    {
      ausdrucksc = strdup(value);
    }
    else
    {
#ifdef DEBUG      
      logmsg(LOG_ERR,"Warnung: Unbekannte Variable %s in %s Zeile %d",name,fileneme,zeile);
#endif
    }
  }
  if(radhosts == NULL) radhosts = new Server(RADHOST);
  if(dbhost == NULL) dbhost = radhosts->name();
  fclose(fp);
  if((name=getenv("RADHOST"))!=NULL)
  {
    /* haenge diesen an die erste Stelle */
    Server *es = new Server(name);
    es->nxt = radhosts;
    radhosts = es;
  }
  return 0;
}

void Clientconf::addradserver(char *host)
{
  Server *sv = new Server(host);
  sv->nxt = radhosts;
  radhosts=sv;
}

void Clientconf::addacctserver(char *host)
{
  Server *sv = new Server(host);
  sv->nxt = radhosts;
  radhosts=sv;
}

int komuwithserver(int sock,Zusenden &frage,Empfangen &antw,Server *sliste,
		   const Clientsecurityinfo &csi,const Clientconf &cc)
{
  int erfolg=0;
  timeval to;
  fd_set readfs;

  for(Server *sv=sliste;sv!=NULL && !erfolg;sv=sv->nxt)
  {
    for(int versuch=0;!erfolg && versuch < cc.radius_retries;versuch++)
    {
      to.tv_sec=cc.radius_timeout;
      to.tv_usec=0L;
      frage.send(sock,sv->addr());
      FD_ZERO(&readfs);
      FD_SET(sock,&readfs);
      if(select(sock+1,&readfs,NULL,NULL,&to)<0)
      {
	if (errno == EINTR) continue;
        logmsg(LOG_ERR, "komuwithserver: select: %s", strerror(errno));
	return 0;
      }
      if(FD_ISSET(sock,&readfs))
      {
	if(antw.recv(sock)>=0)
        {
	  if(antw.check_reply(csi.vector,csi.secret)>=0)
	  {
	     erfolg=1;
	  }
	  else
	  {
	    if(debugflags>0) cout << "Reply-Digest stimmt aber nicht !\n";
	    logmsg(LOG_ERR,"Reply-Digest stimmt nicht !\n");
	    break;
	  }
	}
      }
    }
    if(!erfolg) logmsg(LOG_NOTICE,"Request to Server %s timed out %d times",
		      sv->name(),cc.radius_retries);
  }
  if(!erfolg) logmsg(LOG_ERR,"No server available");
  return erfolg;
}












