/**************************************************************************
 * Headerfile...: radiusclient.h                                          *
 * Zweck........: Allgemeine Routinen (nicht nur ?) fr Radiusclients     *
 *------------------------------------------------------------------------*
 * copyright: 1996 Rudolf Weber W-4 Nonnenbroich und Weber Gbr            *
 *                 Ravensburg,Germany                                     *
 *            1997 Rudolf Weber Informatikberatung Ravensburg             *
 * email: rw@w-4.de                                                       *
 * Rights: see GNU-Copyleft (Distribution only with Source-Code)          *
 * Comericial Users are ask to send money                                 *
 ***************************************************************************/
#ifndef RADIUSCLIENT_H
#define RADIUSCLIENT_H
#include<sys/types.h>
#include<sys/socket.h>
#include<netinet/in.h>
#include<iostream.h>
#include<string.h>
#include<stdlib.h>
#include<unistd.h>
#include<errno.h>
#include"conf.h"
#include"ipaddrtools.h"
#include"secinf.h"
#include"seqnr.h"

/* ffnet socket und schreibt lokale Adresse in salocal */
int opensocket(struct sockaddr_in& salocal);

/* saremote ist die Adresse, die aus einem Rechnernamen oder einer IP_Adresse als String der Form
   "999.999.999.999" und dem Dienst als aus /etc/services gebildet wird
 */
int genempfaddr(struct sockaddr_in &saremote,char *addrstr,char *dienst="radius");
struct in_addr myaddr(); // ermittelt Netzwerk-IP_Adresse

class Server
{
  char *iname;
  sockaddr_in iaddr;
public:
  Server *nxt;
public:
  Server(char *sname,char *dienst="radius")
    {
      iname=strdup(sname);
      genempfaddr(iaddr,sname,dienst);
      nxt=NULL;
    }
  const char *name() { return iname; }
  const short port() { return ntohs(iaddr.sin_port); }
  const sockaddr_in &addr() { return iaddr; }
};

#define AUTH_LOCAL_FST  (1<<0)
#define AUTH_RADIUS_FST (1<<1)
#define AUTH_LOCAL_SND  (1<<2)
#define AUTH_RADIUS_SND (1<<3)


struct Clientconf
{
  Server *radhosts;
  Server *radaccthosts;
  ClientSecinf secinf;
  char *clientpath;
  char *dictpath;
  char *tmpl;
  int maxlogintries;
  int logintimeout; 
  int authorder;
  char *nologin;
  char *issue;
  char *login_radius;
  char *start_ppp;
  char *seqfile;
  char *mapfile;
  char *default_realm;
  long  radius_timeout;
  int  radius_retries;
  char *login_local;
  char *port_pool;
  char *default_path;
  // Ergnzung fr gesamt-Nutzerverwaltung
  const char *dbhost;
  char *ausdrucktmpl;
  char *ausdrucksc;
  Clientconf(); 
  Clientconf(char *cffile);
  void setdefaults();
  int  readconfig(char *filename); // liest Radiushost aus Datei;
  void addradserver(char *host);
  void addacctserver(char *host);
};
char* defaultclientconfigfile();

struct Clientsecurityinfo
{
  u_char vector[AUTH_VECTOR_LEN];
  const u_char *secret;
};

int komuwithserver(int sock,Zusenden &frage,Empfangen &antw,Server *sliste,
		   const Clientsecurityinfo &csi,const Clientconf &cc);
#endif









