/***********************************************************************
 * Modul...: secinf.cc                                                 *
 * Zweck...: Impementiert Klasse ClientSecinf                          *
 * Author..: Rudolf Weber Informatikberatung Ravensburg                *
 * Copyright : GNU                                                     *
 ***********************************************************************/
#include<sys/types.h>
#include<string.h>
#include"secinf.h"

int ClientSecinf::insert(const char *realm,const u_char *secret)
{
  Realminfo **akt = &cur;
  while(*akt != NULL) akt = &((*akt)->nxt);
  *akt = new Realminfo(realm,secret);
  if(!wurzel) wurzel = cur;
}

ClientSecinf::Realminfo *ClientSecinf::finde(const char *realm)
{
  Realminfo *erg;
  int r;
  int z=0;
  if(realm[0]=='*' || realm[0]=='\0')
  {
    cur=wurzel;   // der erste ist der default_realm
    return cur;
  }
  // Ringpuffer, da mehrmals hintereinander das selbe Dingens gesucht wird
  erg=cur;
  if(!erg) erg=wurzel;
  if(!erg) return (Realminfo *)NULL;
  while((r=(strcmp(erg->realm(),realm)!=0)) && (z==0 || erg != cur))
  {
    z++;
    erg = (erg->nxt ? erg->nxt : wurzel );
  }
	
  return ( r ? (Realminfo *)NULL : cur=erg);
}

const u_char *ClientSecinf::secret(struct in_addr ipa,const char *realm)
{
  Realminfo *erg=finde(realm);
  return (erg ? erg->secret() : (u_char *)0);
}




