/**************************************************************************
 * Headerfile...: secinf.h                                                *
 * Zweck........: Klasse Secinf spezifiziert eine Schnittstelle zu einer  *
 *                Tabelle fr Secret realms                               *
 * Author.......: 1997  Rudolf Weber Informatikberatung Ravensburg        *
 * Copyright....: GNU Copyleft                                            *
 **************************************************************************/
#ifndef SECINF_H
#define SECINF_H
#include<sys/types.h>
#include<netinet/in.h>

class Secinf
{
public:
  virtual const u_char *secret(struct in_addr ipa,const char *realm="")=0;
};

class ClientSecinf : public Secinf
{
protected:
  class Realminfo
  {
    char i_realm[56];
    u_char i_secret[256];
  public:  
    Realminfo *nxt;
  public:
    Realminfo(const char *realm,const u_char *sec,Realminfo *next=NULL)
      {
	strncpy(i_realm,realm,56);
	strncpy((char *)i_secret,(const char *)sec,256);
	nxt=next;
      }
    const u_char *secret() { return i_secret; }
    const char *realm() { return i_realm; }
    int passt(const char *vgl)
      {
	return ( i_realm[0]=='*' 
		 || i_realm[0]=='\0' 
		 || strcmp(vgl,i_realm)==0);
      }
  };

  Realminfo *wurzel;
  Realminfo *cur;
  
  Realminfo *finde(const char *realm);
public:
  ClientSecinf() { wurzel=NULL;cur=NULL; }
  int insert(const char *realm,const u_char *secret);
  const u_char *secret(struct in_addr ipa,const char *realm);
};
#endif
