#include<stdlib.h>
#include<stdio.h>
#include<string.h>
#include"logmsg.h"
#include"env.h"

void Env::init(int psize)
{
  maxsize=psize;size=0;
  data=new (char*)[maxsize];
  data[0]=NULL;
}

void Env::import(char **import_env)
{
  char **akt=data;
  char **iakt=import_env;

  while(*iakt !=NULL)
  {
     *akt=*iakt;
     akt++;iakt++;size++;
  }
  akt=NULL;
}

static int envmatch(char *name,char *envitem)
{
  char *n=name;
  char *e=envitem;

  while(*n!='\0' && *e!='=' && *n++==*e++);
  return (*n=='\0' && *e=='=');
}

const char *Env::operator[](char *name)
{
  char **akt=data;
  int erg=0;
  while(*akt!=NULL && !(erg=envmatch(name,*akt))) akt++;
  if(*akt==NULL || !erg) return (char *)NULL;
  return index(*akt,'=')+1;
}

int Env::add(char *name,char *value)
{
   char **akt=data;
   int erg=0;
   char *envnew = (char *)malloc(strlen(name)+strlen(value)+2);
   sprintf(envnew,"%s=%s",name,value);
   while(*akt != NULL && !(erg=envmatch(name,*akt))) akt++;
   if(*akt != NULL && erg) free(*akt);
   *akt=envnew;
   if(!erg)
   {
     if(size+1 >= maxsize)
     {
       logmsg(LOG_ERR,"Env::add: Environment voll");
       return -1;
     }
     size++;
     akt++;
     *akt=NULL;
   }
}

#include<iostream.h>

#ifdef ENVMATCH_TEST
int main(int argc,char **argv)
{
  cout << ( envmatch(argv[1],argv[2]) ? "passt" : "passt nicht ") << endl;
}
#endif
#ifdef ENVTEST
int main(int argc,char **argv,char **env)
{
  Env environ(250);
  environ.import(env);
  environ.add("PATH","/local/radius/bin");

  for(char **akt=environ.export();*akt!=NULL;akt++)
  {
    cout << *akt << endl;
  }

  cout << "HOME: " << environ["HOME"] << endl;
  cout << "PATH: " << environ["PATH"] << endl;
}
#endif
