/*
 * $Id: getifname.c,v 1.5 1996/09/15 11:36:41 lf Exp $
 *
 * Copyright(C) 1995 Lars Fenneberg
 *
 * See the file COPYRIGHT for the respective terms and conditions. 
 * If the file is missing contact me at lf@elemental.net 
 * and I'll send you a copy.
 *
 */


#include<stdio.h>
#include<stdlib.h>
#include<unistd.h>
#include<fcntl.h>
#include<sys/ioctl.h>
#include<string.h>
#include"error.h"

static char rcsid[] = "$Id: getifname.c,v 1.5 1996/09/15 11:36:41 lf Exp $";

/*
 * Purpose:get the network interface name associated with this tty
 * von Lars Feneberg
 */

char *getifname(char *tty)
{
  static char name[512];
  int fd;

  if((fd = open(tty, O_RDWR | O_NDELAY)) < 0)
  {
    error(LOG_ERR, "getifname: can't open %s: %s", tty, strerror(errno));
    return NULL;
  }
  if(ioctl(fd, SIOCGIFNAME, name) < 0)
  {
    error(LOG_ERR, "getifname: can't ioctl %s: %s", tty, strerror(errno));
    return NULL;
  }
  close(fd);

  return name;
}

#ifdef MAIN_GETIFNAME
int main(int argc, char **argv)
{
  char *p;
  char *pname;

  pname =(pname = strrchr(argv[0], '/')) ? pname + 1 : argv[0];

  errorinit_stderr(pname);

  if(argc > 2)
  {
    fprintf(stderr, "usage: %s [filename]", pname);
    return(-1);
  }
  else if(argc == 2)
  {
    p = getifname(argv[1]);
    if(p)
      fputs(p, stdout);
  }
  else
  {
    p = getifname(ttyname(1));
    if(p)
      fputs(p, stdout);
  }

  return 0;
}
#endif
